
{*******************************************************}
{                                                       }
{   Types et structures                                 }
{   du Novell 4.0 Pour Borland DELPHI                   }
{                                                       }
{   Convertion du C au PASCAL                           }
{   par Couery Tanguy le 26/11/95                       }
{                                                       }
{   Pour le projet Novell Netware de 3me anne         }
{   (BRETIN David,COUERY Tanguy,GUILHEM Eric)           }
{                                                       }
{                                                       }
{*******************************************************}

unit TCalls;

interface

type
  PInteger  = ^Integer;
  PByte     = ^Byte;
  PWord     = ^Word;
  PLongInt  = ^LongInt;

{type
PNW_AFP_FILE_INFO = ^NW_AFP_FILE_INFO;
NW_AFP_FILE_INFO = record
   entryID: longint;
   parentID: longint;
   attributes: word;
   dataForkLength: longint;
   resourceForkLength: longint;
   numOffspring: word;
   creationDate: word;
   accessDate: word;
   modifyDate: word;
   modifyTime: word;
   backupDate: word;
   backupTime: word;
   finderInfo: array [0..31] of byte;
   longName: array [0..33] of char;
   ownerID: longint;
   shortName: array [0..13] of char;
   accessPrivileges: word;
   proDOSInfo: array [0..5] of byte;
end;

type NW_AFP_SET_INFO = record
   attributes: word;
   creationDate: word;
   accessDate: word;
   modifyDate: word;
   modifyTime: word;
   backupDate: word;
   backupTime: word;
   finderInfo: array [0..31] of byte;
   proDOSInfo: array [0..5] of byte;
end;
type PNW_AFP_SET_INFO= ^NW_AFP_SET_INFO;

type CONN_USE = record
   systemElapsedTime: longint;
   bytesRead: array [0..5] of byte;
   bytesWritten: array [0..5] of byte;
   totalRequestPackets: longint;
end;
type PCONN_USE= ^CONN_USE;

type NWINET_ADDR = record
   networkAddr: array [0..3] of byte;
   netNodeAddr: array [0..5] of byte;
   socket: word;
   connType: word;
end;
type PNWINET_ADDR = ^NWINET_ADDR;

type CONNECT_INFO = record
   connID: word;
   connectFlags: word;
   sessionID: word;
   connNumber: word;
   serverAddr: array [0..11] of byte;
   serverType: word;
   serverName: array [0..47] of char;
   clientType: word;
   clientName: array [0..47] of char;
end;
type PCONNECT_INFO = ^CONNECT_INFO;

type NWDELETED_INFO = record
   sequence: longint;
   parent: longint;
   attributes: longint;
   uniqueID: byte;
   flags: byte;
   nameSpace: byte;
   nameLength: byte;
   name: array [0..255] of byte;
   creationDateAndTime: longint;
   ownerID: longint;
   lastArchiveDateAndTime: longint;
   lastArchiverID: longint;
   updateDateAndTime: longint;
   updatorID: longint;
   fileSize: longint;
   reserved: array [0..43] of byte;
   inheritedRightsMask: word;
   lastAccessDate: word;
   deletedTime: longint;
   deletedDateAndTime: longint;
   deletorID: longint;
   reserved3: array [0..15] of byte;
end;
type PNWDELETED_INFO = ^NWDELETED_INFO;

type TRUSTEE_INFO = record
   objectID: longint;
   objectRights: word;
end;
type PTRUSTEE_INFO = ^TRUSTEE_INFO;

type DIR_SPACE_INFO = record
   totalBlocks: longint;
   availableBlocks: longint;
   purgeableBlocks: longint;
   notYetPurgeableBlocks: longint;
   totalDirEntries: longint;
   availableDirEntries: longint;
   reserved: longint;
   sectorsPerBlock: byte;
   volLen: byte;
   volName: array [0..16] of byte;
end;
type PDIR_SPACE_INFO = ^DIR_SPACE_INFO;

type NWFILE_INFO = record
   updateDateAndTime: longint;
   updatorID: longint;
   fileSize: longint;
   reserved: array [0..43] of byte;
   inheritedRightsMask: word;
   lastAccessDate: word;
   reserved2: array [0..27] of byte;
end;
type PNWFILE_INFO = ^NWFILE_INFO;

type NWDIR_INFO = record
   lastModifyDateAndTime: longint;
   nextTrusteeEntry: longint;
   reserved: array [0..47] of byte;
   maximumSpace: longint;
   inheritedRightsMask: word;
   reserved2: array [0..13] of byte;
   volObjectID: longint;
   reserved3: array [0..7] of byte;
end;
type PNWDIR_INFO = ^NWDIR_INFO;

type
PNWENTRY_INFO = ^NWENTRY_INFO;
NWENTRY_INFO = record
   sequence: longint;
   parent: longint;
   attributes: longint;
   uniqueID: byte;
   flags: byte;
   nameSpace: byte;
   nameLength: byte;
   name: array [0..11] of byte;
   creationDateAndTime: longint;
   ownerID: longint;
   lastArchiveDateAndTime: longint;
   lastArchiverID: longint;
   info: record
case integer of
   0: (_file: NWFILE_INFO);
   1: (dir: NWDIR_INFO);
end;
end;

type NWET_INFO = record
   entryName: array [0..15] of char;
   creationDateAndTime: longint;
   ownerID: longint;
   sequenceNumber: longint;
   trusteeList: array [0..19] of TRUSTEE_INFO;
end;
type PNWET_INFO = ^NWET_INFO;

type NW_EXT_FILE_INFO = record
   sequence: longint;
   parent: longint;
   attributes: longint;
   uniqueID: byte;
   flags: byte;
   nameSpace: byte;
   nameLength: byte;
   name: array [0..11] of byte;
   creationDateAndTime: longint;
   ownerID: longint;
   lastArchiveDateAndTime: longint;
   lastArchiverID: longint;
   updateDateAndTime: longint;
   lastUpdatorID: longint;
   dataForkSize: longint;
   dataForkFirstFAT: longint;
   nextTrusteeEntry: longint;
   reserved: array [0..35] of byte;
   inheritedRightsMask: word;
   lastAccessDate: word;
   deletedFileTime: longint;
   deletedDateAndTime: longint;
   deletorID: longint;
   reserved2: array [0..15] of byte;
   otherForkSize: array [0..1] of longint;
end;
type PNW_EXT_FILE_INFO = ^NW_EXT_FILE_INFO;

type NW_IDX = record
   volNumber: byte;
   srcNameSpace: byte;
   srcDirBase: longint;
   dstNameSpace: byte;
   dstDirBase: longint;
end;
type PNW_IDX = ^NW_IDX;

type SEARCH_SEQUENCE = record
   volNumber: byte;
   dirNumber: longint;
   searchDirNumber: longint;
end;
type PSEARCH_SEQUENCE = ^SEARCH_SEQUENCE;

type NW_ENTRY_INFO = record
   spaceAlloc: longint;
   attributes: longint;
   flags: word;
   dataStreamSize: longint;
   totalStreamSize: longint;
   numberOfStreams: word;
   creationTime: word;
   creationDate: word;
   creatorID: longint;
   modifyTime: word;
   modifyDate: word;
   modifierID: longint;
   lastAccessDate: word;
   archiveTime: word;
   archiveDate: word;
   archiverID: longint;
   inheritedRightsMask: word;
   dirEntNum: longint;
   DosDirNum: longint;
   volNumber: longint;
   EADataSize: longint;
   EAKeyCount: longint;
   EAKeySize: longint;
   NSCreator: longint;
   nameLength: byte;
   entryName: array [0..255] of byte;
end;
type PNW_ENTRY_INFO = ^NW_ENTRY_INFO;

type NW_NS_OPEN = record
   openCreateMode: byte;
   searchAttributes: word;
   reserved: longint;
   createAttributes: longint;
   accessRights: word;
   NetWareHandle: longint;
   openCreateAction: byte;
end;
type PNW_NS_OPEN = ^NW_NS_OPEN;
type NW_NS_OPENCREATE = NW_NS_OPEN;
type PNW_NS_OPENCREATE = ^NW_NS_OPENCREATE;


type NW_NS_INFO = record
   NSInfoBitMask: longint;
   fixedBitMask: longint;
   reservedBitMask: longint;
   extendedBitMask: longint;
   fixedBitsDefined: word;
   reservedBitsDefined: word;
   extendedBitsDefined: word;
   fieldsLenTable: array [0..31] of longint;
   hugeStateInfo: array [0..15] of byte;
   hugeDataLength: longint;
end;
type PNW_NS_INFO = ^NW_NS_INFO;

type NW_NS_PATH = record
   srcPath: Pchar;
   dstPath: Pchar;
   dstPathSize: word;
end;
type PNW_NS_PATH = ^NW_NS_PATH;

type MODIFY_DOS_INFO = record
   attributes: longint;
   createDate: word;
   createTime: word;
   creatorID: longint;
   modifyDate: word;
   modifyTime: word;
   modifierID: longint;
   archiveDate: word;
   archiveTime: word;
   archiverID: longint;
   lastAccessDate: word;
   inheritanceGrantMask: word;
   inheritanceRevokeMask: word;
   maximumSpace: longint;
end;
type PMODIFY_DOS_INFO = ^MODIFY_DOS_INFO;

type NW_EA_HANDLE = record
   connID: word;
   rwPosition: longint;
   EAHandle: longint;
   volNumber: longint;
   dirBase: longint;
   keyUsed: byte;
   keyLength: word;
   key: array [0..255] of byte;
end;
type PNW_EA_HANDLE = ^NW_EA_HANDLE;

type NW_EA_FF_STRUCT = record
   connID: word;
   nextKeyOffset: word;
   nextKey: word;
   numKeysRead: longint;
   totalKeys: longint;
   EAHandle: longint;
   sequence: word;
   numKeysInBuffer: word;
   enumBuffer: array [0..511] of byte;
end;
type PNW_EA_FF_STRUCT = ^NW_EA_FF_STRUCT;

type NW_FILE_INFO = record
   fileName: array [0..13] of char;
   fileAttributes: byte;
   extendedFileAttributes: byte;
   fileSize: longint;
   creationDate: word;
   lastAccessDate: word;
   lastUpdateDateAndTime: longint;
   fileOwnerID: longint;
   lastArchiveDateAndTime: longint;
end;
type PNW_FILE_INFO = ^NW_FILE_INFO;

type NW_FILE_INFO2 = record
   fileAttributes: byte;
   extendedFileAttributes: byte;
   fileSize: longint;
   creationDate: word;
   lastAccessDate: word;
   lastUpdateDateAndTime: longint;
   fileOwnerID: longint;
   lastArchiveDateAndTime: longint;
   fileName: array [0..259] of char;
end;
type PNW_FILE_INFO2 = ^NW_FILE_INFO2;

type CONN_USING_FILE = record
   connNumber: word;
   taskNumber: word;
   lockType: byte;
   accessControl: byte;
   lockFlag: byte;
end;
type PCONN_USING_FILE = ^CONN_USING_FILE;

type CONNS_USING_FILE = record
   nextRequest: word;
   useCount: word;
   openCount: word;
   openForReadCount: word;
   openForWriteCount: word;
   denyReadCount: word;
   denyWriteCount: word;
   locked: byte;
   forkCount: byte;
   connCount: word;
   connInfo: array [0..69] of CONN_USING_FILE;
end;
type PCONNS_USING_FILE = ^CONNS_USING_FILE;

type OPEN_FILE_CONN_CTRL = record
   nextRequest: word;
   openCount: word;
   buffer: array [0..511] of byte;
   curRecord: word;
end;
type POPEN_FILE_CONN_CTRL = ^OPEN_FILE_CONN_CTRL;

type OPEN_FILE_CONN = record
   taskNumber: word;
   lockType: byte;
   accessControl: byte;
   lockFlag: byte;
   volNumber: byte;
   parent: longint;
   dirEntry: longint;
   forkCount: byte;
   nameSpace: byte;
   nameLen: byte;
   fileName: array [0..254] of char;
end;
type POPEN_FILE_CONN = ^OPEN_FILE_CONN;

type CONN_OPEN_FILE = record
   taskNumber: byte;
   lockType: byte;
   accessControl: byte;
   lockFlag: byte;
   volNumber: byte;
   dirEntry: word;
   fileName: array [0..13] of char;
end;
type PCONN_OPEN_FILE = ^CONN_OPEN_FILE;

type CONN_OPEN_FILES = record
   nextRequest: word;
   connCount: byte;
   connInfo: array [0..21] of CONN_OPEN_FILE;
end;
type PCONN_OPEN_FILES = ^CONN_OPEN_FILES;

type NW_DATE = record
   day: byte;
   month: byte;
   year: word;
end;
type PNW_DATE = ^NW_DATE;

type NW_TIME = record
   seconds: byte;
   minutes: byte;
   hours: word;
end;
type PNW_TIME = ^NW_TIME;

type NW_FRAGMENT = record
   fragAddress: pointer;
   fragSize: word;
end;
type PNW_FRAGMENT = ^NW_FRAGMENT;

type NW_REQUESTER_TYPE = (
NW_LONG_NAME_REQUESTER,
NW_SHORT_NAME_REQUESTER,
NW_ERROR_ON_REQUESTER_TYPE
);
type PNW_REQUESTER_TYPE = ^NW_REQUESTER_TYPE;

type DIR_ENTRY = record
   volNumber: byte;
   dirEntry: longint;
end;
type PDIR_ENTRY = ^DIR_ENTRY;

type CONN_TASK = record
   taskNumber: word;
   taskState: byte;
end;
type PCONN_TASK = ^CONN_TASK;

type CONN_TASK_INFO = record
   serverVersion: word;
   lockState: byte;
   waitingTaskNumber: word;
   recordStart: longint;
   recordEnd: longint;
   volNumber: byte;
   dirEntry: longint;
   nameSpace: byte;
   dirID: word;
   lockedName: array [0..255] of char;
   taskCount: byte;
   tasks: array [0..255] of CONN_TASK;
end;
type PCONN_TASK_INFO = ^CONN_TASK_INFO;

type PRINTER_STATUS = record
   printerHalted: byte;
   printerOffline: byte;
   currentFormType: byte;
   redirectedPrinter: byte;
end;
type PPRINTER_STATUS = ^PRINTER_STATUS;

type NWCAPTURE_FLAGSRW = record
   jobDescription: array [0..49] of byte;
   jobControlFlags: byte;
   tabSize: byte;
   numCopies: word;
   printFlags: word;
   maxLines: word;
   maxChars: word;
   formName: array [0..12] of byte;
   reserved: array [0..8] of byte;
   formType: word;
   bannerText: array [0..12] of byte;
   reserved2: byte;
   flushCaptureTimeout: word;
   flushCaptureOnClose: byte;
end;
type PNWCAPTURE_FLAGSRW = ^NWCAPTURE_FLAGSRW;

type NWCAPTURE_FLAGSRO = record
   connID: word;
   queueID: longint;
   setupStringMaxLen: word;
   resetStringMaxLen: word;
   LPTCaptureFlag: byte;
   fileCaptureFlag: byte;
   timingOutFlag: byte;
   inProgress: byte;
   printQueueFlag: byte;
   printJobValid: byte;
   queueName: array [0..64] of char;
end;
type PNWCAPTURE_FLAGSRO = ^NWCAPTURE_FLAGSRO;

type NWPrintJobStruct = record
   clientStation: longint;
   clientTask: longint;
   clientID: longint;
   targetServerID: longint;
   targetExecutionTime: array [0..5] of byte;
   jobEntryTime: array [0..5] of byte;
   jobNumber: longint;
   formType: word;
   jobPosition: word;
   jobControlFlags: word;
   jobFileName: array [0..13] of byte;
   jobFileHandle: longint;
   servicingServerStation: longint;
   servicingServerTask: longint;
   servicingServerID: longint;
   jobDescription: array [0..49] of byte;
   clientJobInfoVer: byte;
   tabSize: byte;
   numberCopies: word;
   printFlags: word;
   maxLines: word;
   maxChars: word;
   formName: array [0..15] of byte;
   reserved: array [0..5] of byte;
   bannerUserName: array [0..12] of byte;
   bannerFileName: array [0..12] of byte;
   bannerHeaderFileName: array [0..13] of byte;
   filePathName: array [0..79] of byte;
end;
type PNWPrintJobStruct = ^NWPrintJobStruct;

type QueueJobStruct = record
   clientStation: byte;
   clientTask: byte;
   clientID: longint;
   targetServerID: longint;
   targetExecutionTime: array [0..5] of byte;
   jobEntryTime: array [0..5] of byte;
   jobNumber: word;
   jobType: word;
   jobPosition: byte;
   jobControlFlags: byte;
   jobFileName: array [0..13] of byte;
   jobFileHandle: array [0..5] of byte;
   servicingServerStation: byte;
   servicingServerTask: byte;
   servicingServerID: longint;
   jobDescription: array [0..49] of byte;
   clientRecordArea: array [0..151] of byte;
end;
type PQueueJobStruct = ^QueueJobStruct;

type NWQueueJobStruct = record
   clientStation: longint;
   clientTask: longint;
   clientID: longint;
   targetServerID: longint;
   targetExecutionTime: array [0..5] of byte;
   jobEntryTime: array [0..5] of byte;
   jobNumber: longint;
   jobType: word;
   jobPosition: word;
   jobControlFlags: word;
   jobFileName: array [0..13] of byte;
   jobFileHandle: longint;
   servicingServerStation: longint;
   servicingServerTask: longint;
   servicingServerID: longint;
   jobDescription: array [0..49] of byte;
   clientRecordArea: array [0..151] of byte;
end;
type PNWQueueJobStruct = ^NWQueueJobStruct;

type QueueJobListReply = record
   totalQueueJobs: longint;
   replyQueueJobNumbers: longint;
   jobNumberList: array [0..249] of longint;
end;
type PQueueJobListReply = ^QueueJobListReply;

type PHYS_DSK_STATS = record
   systemElapsedTime: longint;
   diskChannel: byte;
   diskRemovable: byte;
   driveType: byte;
   controllerDriveNumber: byte;
   controllerNumber: byte;
   controllerType: byte;
   driveSize: longint;
   driveCylinders: word;
   driveHeads: byte;
   sectorsPerTrack: byte;
   driveDefinition: array [0..63] of byte;
   IOErrorCount: word;
   hotFixStart: longint;
   hotFixSize: word;
   hotFixBlockAvailable: word;
   hotFixDisabled: byte;
end;
type PPHYS_DSK_STATS = ^PHYS_DSK_STATS;

type FILESYS_STATS = record
   systemElapsedTime: longint;
   maxOpenFiles: word;
   maxFilesOpened: word;
   currOpenFiles: word;
   totalFilesOpened: longint;
   totalReadRequests: longint;
   totalWriteRequests: longint;
   currChangedFATSectors: word;
   totalChangedFATSectors: longint;
   FATWriteErrors: word;
   fatalFATWriteErrors: word;
   FATScanErrors: word;
   maxIndexFilesOpened: word;
   currOpenIndexedFiles: word;
   attachedIndexFiles: word;
   availableIndexFiles: word;
end;
type PFILESYS_STATS = ^FILESYS_STATS;

type DSK_CHANNEL_STATS = record
   systemElapsedTime: longint;
   channelState: word;
   channelSyncState: word;
   driverType: byte;
   driverMajorVersion: byte;
   driverMinorVersion: byte;
   driverDescription: array [0..64] of byte;
   IOAddr1: word;
   IOAddr1Size: word;
   IOAddr2: word;
   IOAddr2Size: word;
   sharedMem1Seg: array [0..2] of byte;
   sharedMem1Ofs: word;
   sharedMem2Seg: array [0..2] of byte;
   sharedMem2Ofs: word;
   interrupt1Used: byte;
   interrupt1: byte;
   interrupt2Used: byte;
   interrupt2: byte;
   DMAChannel1Used: byte;
   DMAChannel1: byte;
   DMAChannel2Used: byte;
   DMAChannel2: byte;
   reserved2: word;
   configDescription: array [0..79] of byte;
end;
type PDSK_CHANNEL_STATS = ^DSK_CHANNEL_STATS;

type DSK_CACHE_STATS = record
   systemElapsedTime: longint;
   cacheBufferCount: word;
   cacheBufferSize: word;
   dirtyCacheBuffers: word;
   cacheReadRequests: longint;
   cacheWriteRequests: longint;
   cacheHits: longint;
   cacheMisses: longint;
   physicalReadRequests: longint;
   physicalWriteRequests: longint;
   physicalReadErrors: word;
   physicalWriteErrors: word;
   cacheGetRequests: longint;
   cacheFullWriteRequests: longint;
   cachePartialWriteRequests: longint;
   backgroundDirtyWrites: longint;
   backgroundAgedWrites: longint;
   totalCacheWrites: longint;
   cacheAllocations: longint;
   thrashingCount: word;
   LRUBlockWasDirtyCount: word;
   readBeyondWriteCount: word;
   fragmentedWriteCount: word;
   cacheHitOnUnavailCount: word;
   cacheBlockScrappedCount: word;
end;
type PDSK_CACHE_STATS = ^DSK_CACHE_STATS;

type DRV_MAP_TABLE = record
   systemElapsedTime: longint;
   SFTSupportLevel: byte;
   logicalDriveCount: byte;
   physicalDriveCount: byte;
   diskChannelTable: array [0..4] of byte;
   pendingIOCommands: word;
   driveMappingTable: array [0..31] of byte;
   driveMirrorTable: array [0..31] of byte;
   deadMirrorTable: array [0..31] of byte;
   reMirrorDriveNumber: byte;
   reserved: byte;
   reMirrorCurrentOffset: longint;
   SFTErrorTable: array [0..59] of word;
end;
type PDRV_MAP_TABLE = ^DRV_MAP_TABLE;

type NWLAN_CONFIG = record
   networdAddress: array [0..3] of byte;
   hostAddress: array [0..5] of byte;
   boardInstalled: byte;
   optionNumber: byte;
   configurationText1: array [0..79] of byte;
   configurationText2: array [0..79] of byte;
end;
type PNWLAN_CONFIG = ^NWLAN_CONFIG;

type SERVER_LAN_IO_STATS = record
   systemElapsedTime: longint;
   maxRoutingBuffersAvail: word;
   maxRoutingBuffersUsed: word;
   routingBuffersInUse: word;
   totalFileServicePackets: longint;
   fileServicePacketsBuffered: word;
   invalidConnPacketCount: word;
   badLogicalConnCount: word;
   packetsRcvdDuringProcCount: word;
   reprocessedRequestCount: word;
   badSequenceNumberPacketCount: word;
   duplicateReplyCount: word;
   acknowledgementsSent: word;
   badRequestTypeCount: word;
   attachDuringProcCount: word;
   attachWhileAttachingCount: word;
   forgedDetachRequestCount: word;
   badConnNumberOnDetachCount: word;
   detachDuringProcCount: word;
   repliesCanceledCount: word;
   hopCountDiscardCount: word;
   unknownNetDiscardCount: word;
   noDGroupBufferDiscardCount: word;
   outPacketNoBufferDiscardCount: word;
   IPXNotMyNetworkCount: word;
   NetBIOSPropagationCount: longint;
   totalOtherPackets: longint;
   totalRoutedPackets: longint;
end;
type PSERVER_LAN_IO_STATS = ^SERVER_LAN_IO_STATS;

type VERSION_INFO = record
   serverName: array [0..47] of byte;
   fileServiceVersion: byte;
   fileServiceSubVersion: byte;
   maximumServiceConnections: word;
   connectionsInUse: word;
   maxNumberVolumes: word;
   revision: byte;
   SFTLevel: byte;
   TTSLevel: byte;
   maxConnectionsEverUsed: word;
   accountVersion: byte;
   VAPVersion: byte;
   queueVersion: byte;
   printVersion: byte;
   virtualConsoleVersion: byte;
   restrictionLevel: byte;
   internetBridge: byte;
   reserved: array [0..59] of byte;
end;
type PVERSION_INFO = ^VERSION_INFO;

type NW_DYNAMIC_MEM = record
   total: longint;
   max: longint;
   cur: longint;
end;
type PNW_DYNAMIC_MEM = ^NW_DYNAMIC_MEM;

type NW_FS_INFO = record
   upTime: longint;
   processor: byte;
   reserved: byte;
   numProcs: byte;
   utilization: byte;
   configuredObjs: word;
   maxObjs: word;
   curObjs: word;
   totalMem: word;
   unusedMem: word;
   numMemAreas: word;
   dynamicMem: array [0..2] of NW_DYNAMIC_MEM;
end;
type PNW_FS_INFO = ^NW_FS_INFO;

type PHYSICAL_LOCK = record
   loggedCount: word;
   shareableLockCount: word;
   recordStart: longint;
   recordEnd: longint;
   connNumber: word;
   taskNumber: word;
   lockType: byte;
end;
type PPHYSICAL_LOCK = ^PHYSICAL_LOCK;

type PHYSICAL_LOCKS = record
   nextRequest: word;
   numRecords: word;
   locks: array [0..31] of PHYSICAL_LOCK;
   curRecord: word;
   reserved: array [0..7] of byte;
end;
type PPHYSICAL_LOCKS = ^PHYSICAL_LOCKS;

type CONN_PHYSICAL_LOCK = record
   taskNumber: word;
   lockType: byte;
   recordStart: longint;
   recordEnd: longint;
end;
type PCONN_PHYSICAL_LOCK = ^CONN_PHYSICAL_LOCK;

type CONN_PHYSICAL_LOCKS = record
   nextRequest: word;
   numRecords: word;
   locks: array [0..50] of CONN_PHYSICAL_LOCK;
   curRecord: word;
   reserved: array [0..21] of byte;
end;
type PCONN_PHYSICAL_LOCKS = ^CONN_PHYSICAL_LOCKS;

type CONN_LOGICAL_LOCKS = record
   nextRequest: word;
   numRecords: word;
   records: array [0..507] of byte;
   curOffset: word;
   curRecord: word;
end;
type PCONN_LOGICAL_LOCKS = ^CONN_LOGICAL_LOCKS;

type CONN_LOGICAL_LOCK = record
   taskNumber: word;
   lockStatus: byte;
   logicalName: array [0..127] of char;
end;
type PCONN_LOGICAL_LOCK = ^CONN_LOGICAL_LOCK;

type LOGICAL_LOCK = record
   connNumber: word;
   taskNumber: word;
   lockStatus: byte;
end;
type PLOGICAL_LOCK = ^LOGICAL_LOCK;

type LOGICAL_LOCKS = record
   useCount: word;
   shareableLockCount: word;
   locked: byte;
   nextRequest: word;
   numRecords: word;
   logicalLock: array [0..127] of LOGICAL_LOCK;
   curRecord: word;
end;
type PLOGICAL_LOCKS = ^LOGICAL_LOCKS;

type SEMAPHORE = record
   connNumber: word;
   taskNumber: word;
end;
type PSEMAPHORE = ^SEMAPHORE;

type SEMAPHORES = record
   nextRequest: word;
   openCount: word;
   semaphoreValue: word;
   semaphoreCount: word;
   semaphores: array [0..169] of SEMAPHORE;
   curRecord: word;
end;
type PSEMAPHORES = ^SEMAPHORES;

type CONN_SEMAPHORE = record
   openCount: word;
   semaphoreValue: word;
   taskNumber: word;
   semaphoreName: array [0..127] of char;
end;
type PCONN_SEMAPHORE = ^CONN_SEMAPHORE;

type CONN_SEMAPHORES = record
   nextRequest: word;
   numRecords: word;
   records: array [0..507] of byte;
   curOffset: word;
   curRecord: word;
end;
type PCONN_SEMAPHORES = ^CONN_SEMAPHORES;

type TTS_STATS = record
   systemElapsedTime: longint;
   TTS_Supported: byte;
   TTS_Enabled: byte;
   TTS_VolumeNumber: word;
   TTS_MaxOpenTransactions: word;
   TTS_MaxTransactionsOpened: word;
   TTS_CurrTransactionsOpen: word;
   TTS_TotalTransactions: longint;
   TTS_TotalWrites: longint;
   TTS_TotalBackouts: longint;
   TTS_UnfilledBackouts: word;
   TTS_DiskBlocksInUse: word;
   TTS_FATAllocations: longint;
   TTS_FileSizeChanges: longint;
   TTS_FilesTruncated: longint;
   numberOfTransactions: byte;
   connTask: array [0..234] of record
   	connNumber: byte;
   	taskNumber: byte;
	end;
end;
type PTTS_STATS = ^TTS_STATS;

type NWVolumeRestrictions = record
   numberOfEntries: byte;
   resInfo: array [0..11] of record
   objectID: longint;
   restriction: longint;
end;
end;
type PNWVolumeRestrictions = ^NWVolumeRestrictions;

type NWVOL_RESTRICTIONS = record
   numberOfEntries: byte;
   resInfo: array [0..15] of record
   objectID: longint;
   restriction: longint;
end;
end;
type PNWVOL_RESTRICTIONS = ^NWVOL_RESTRICTIONS;

type VOL_STATS = record
   systemElapsedTime: longint;
   volumeNumber: byte;
   logicalDriveNumber: byte;
   sectorsPerBlock: word;
   startingBlock: word;
   totalBlocks: word;
   availableBlocks: word;
   totalDirectorySlots: word;
   availableDirectorySlots: word;
   maxDirectorySlotsUsed: word;
   isHashing: byte;
   isCaching: byte;
   isRemovable: byte;
   isMounted: byte;
   volumeName: array [0..15] of char;
end;
type PVOL_STATS = ^VOL_STATS;

type NWVolExtendedInfo = record
   volType: longint;
   statusFlag: longint;
   sectorSize: longint;
   sectorsPerCluster: longint;
   volSizeInClusters: longint;
   freeClusters: longint;
   subAllocFreeableClusters: longint;
   freeableLimboSectors: longint;
   nonfreeableLimboSectors: longint;
   availSubAllocSectors: longint;
   nonuseableSubAllocSectors: longint;
   subAllocClusters: longint;
   numDataStreams: longint;
   numLimboDataStreams: longint;
   oldestDelFileAgeInTicks: longint;
   numCompressedDataStreams: longint;
   numCompressedLimboDataStreams: longint;
   numNoncompressibleDataStreams: longint;
   precompressedSectors: longint;
   compressedSectors: longint;
   numMigratedDataStreams: longint;
   migratedSectors: longint;
   clustersUsedByFAT: longint;
   clustersUsedByDirs: longint;
   clustersUsedByExtDirs: longint;
   totalDirEntries: longint;
   unusedDirEntries: longint;
   totalExtDirExtants: longint;
   unusedExtDirExtants: longint;
   extAttrsDefined: longint;
   extAttrExtantsUsed: longint;
   DirectoryServicesObjectID: longint;
   volLastModifiedDateAndTime: longint;
end;
type PNWVolExtendedInfo = ^NWVolExtendedInfo;

type HOLDS_INFO = record
   objectID: longint;
   amount: longint;
end;
type PHOLDS_INFO = ^HOLDS_INFO;

type HOLDS_STATUS = record
   holdsCount: word;
   holds: array [0..15] of HOLDS_INFO;
end;
type PHOLDS_STATUS = ^HOLDS_STATUS;

type CACHE_MEM_COUNTERS = record
   originalNumOfCacheBuffers: longint;
   currentNumOfCacheBuffers: longint;
   cacheDirtyBlockThreshold: longint;
   waitNodeCount: longint;
   waitNodeAllocFailureCount: longint;
   moveCacheNodeCount: longint;
   moveCacheNodeFromAvailCount: longint;
   accelerateCacheNodeWriteCount: longint;
   removeCacheNodeCount: longint;
   removeCacheNodeFromAvailCount: longint;
end;
type PCACHE_MEM_COUNTERS = ^CACHE_MEM_COUNTERS;

type SERVER_AND_VCONSOLE_INFO = record
   currentServerTime: longint;
   vconsoleVersion: byte;
   vconsoleRevision: byte;
end;
type PSERVER_AND_VCONSOLE_INFO = ^SERVER_AND_VCONSOLE_INFO;

type CACHE_COUNTERS = record
   readExistingBlockCount: longint;
   readExistingWriteWaitCount: longint;
   readExistingPartialReadCount: longint;
   readExistingReadErrorCount: longint;
   writeBlockCount: longint;
   writeEntireBlockCount: longint;
   getDiskCount: longint;
   getDiskNeedToAllocCount: longint;
   getDiskSomeoneBeatMeCount: longint;
   getDiskPartialReadCount: longint;
   getDiskReadErrorCount: longint;
   getAsyncDiskCount: longint;
   getAsyncDiskNeedToAlloc: longint;
   getAsyncDiskSomeoneBeatMe: longint;
   errorDoingAsyncReadCount: longint;
   getDiskNoReadCount: longint;
   getDiskNoReadAllocCount: longint;
   getDiskNoReadSomeoneBeatMeCount: longint;
   diskWriteCount: longint;
   diskWriteAllocCount: longint;
   diskWriteSomeoneBeatMeCount: longint;
   writeErrorCount: longint;
   waitOnSemaphoreCount: longint;
   allocBlockWaitForSomeoneCount: longint;
   allocBlockCount: longint;
   allocBlockWaitCount: longint;
end;
type PCACHE_COUNTERS = ^CACHE_COUNTERS;

type CACHE_TREND_COUNTERS = record
   numCacheChecks: longint;
   numCacheHits: longint;
   numDirtyCacheChecks: longint;
   numDirtyCacheHits: longint;
   cacheUsedWhileChecking: longint;
   waitForDirtyBlocksDecreaseCount: longint;
   allocBlockFromAvailCount: longint;
   allocBlockFromLRUCount: longint;
   allocBlockAlreadyWaiting: longint;
   LRUSittingTime: longint;
end;
type PCACHE_TREND_COUNTERS = ^CACHE_TREND_COUNTERS;

type CACHE_INFO = record
   maxByteCount: longint;
   minNumOfCacheBuffers: longint;
   minCacheReportThreshold: longint;
   allocWaitingCount: longint;
   numDirtyBlocks: longint;
   cacheDirtyWaitTime: longint;
   cacheMaxConcurrentWrites: longint;
   maxDirtyTime: longint;
   numOfDirCacheBuffers: longint;
   cacheByteToBlockShiftFactor: longint;
end;
type PCACHE_INFO = ^CACHE_INFO;

type NWFSE_CACHE_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   cacheCounters: CACHE_COUNTERS;
   cacheMemCounters: CACHE_MEM_COUNTERS;
   cacheTrendCounters: CACHE_TREND_COUNTERS;
   cacheInformation: CACHE_INFO;
end;
type PNWFSE_CACHE_INFO = ^NWFSE_CACHE_INFO;

type FSE_SERVER_INFO = record
   replyCanceledCount: longint;
   writeHeldOffCount: longint;
   writeHeldOffWithDupRequest: longint;
   invalidRequestTypeCount: longint;
   beingAbortedCount: longint;
   alreadyDoingReallocCount: longint;
   deAllocInvalidSlotCount: longint;
   deAllocBeingProcessedCount: longint;
   deAllocForgedPacketCount: longint;
   deAllocStillTransmittingCount: longint;
   startStationErrorCount: longint;
   invalidSlotCount: longint;
   beingProcessedCount: longint;
   forgedPacketCount: longint;
   stillTransmittingCount: longint;
   reExecuteRequestCount: longint;
   invalidSequenceNumCount: longint;
   duplicateIsBeingSentAlreadyCnt: longint;
   sentPositiveAcknowledgeCount: longint;
   sentDuplicateReplyCount: longint;
   noMemForStationCtrlCount: longint;
   noAvailableConnsCount: longint;
   reallocSlotCount: longint;
   reallocSlotCameTooSoonCount: longint;
end;
type PFSE_SERVER_INFO = ^FSE_SERVER_INFO;

type FILE_SERVER_COUNTERS = record
   tooManyHops: word;
   unknownNetwork: word;
   noSpaceForService: word;
   noReceiveBuffers: word;
   notMyNetwork: word;
   netBIOSProgatedCount: longint;
   totalPacketsServiced: longint;
   totalPacketsRouted: longint;
end;
type PFILE_SERVER_COUNTERS = ^FILE_SERVER_COUNTERS;

type NWFSE_FILE_SERVER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   NCPStationsInUseCount: longint;
   NCPPeakStationsInUseCount: longint;
   numOfNCPRequests: longint;
   serverUtilization: longint;
   ServerInfo: FSE_SERVER_INFO;
   fileServerCounters: FILE_SERVER_COUNTERS;
end;
type PNWFSE_FILE_SERVER_INFO = ^NWFSE_FILE_SERVER_INFO;

type FSE_FILE_SYSTEM_INFO = record
   FATMovedCount: longint;
   FATWriteErrorCount: longint;
   someoneElseDidItCount0: longint;
   someoneElseDidItCount1: longint;
   someoneElseDidItCount2: longint;
   iRanOutSomeoneElseDidItCount0: longint;
   iRanOutSomeoneElseDidItCount1: longint;
   iRanOutSomeoneElseDidItCount2: longint;
   turboFATBuildScrededUpCount: longint;
   extraUseCountNodeCount: longint;
   extraExtraUseCountNodeCount: longint;
   errorReadingLastFATCount: longint;
   someoneElseUsingThisFileCount: longint;
end;
type PFSE_FILE_SYSTEM_INFO = ^FSE_FILE_SYSTEM_INFO;

type NWFSE_FILE_SYSTEM_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   fileSystemInfo: FSE_FILE_SYSTEM_INFO;
end;
type PNWFSE_FILE_SYSTEM_INFO = ^NWFSE_FILE_SYSTEM_INFO;

type USER_INFO = record
   connNum: longint;
   useCount: longint;
   connServiceType: byte;
   loginTime: array [0..6] of byte;
   status: longint;
   expirationTime: longint;
   objType: longint;
   transactionFlag: byte;
   logicalLockThreshold: byte;
   recordLockThreshold: byte;
   fileWriteFlags: byte;
   fileWriteState: byte;
   filler: byte;
   fileLockCount: word;
   recordLockCount: word;
   totalBytesRead: array [0..5] of byte;
   totalBytesWritten: array [0..5] of byte;
   totalRequests: longint;
   heldRequests: longint;
   heldBytesRead: array [0..5] of byte;
   heldBytesWritten: array [0..5] of byte;
end;
type PUSER_INFO = ^USER_INFO;

type NWFSE_USER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   userInfo: USER_INFO;
end;
type PNWFSE_USER_INFO = ^NWFSE_USER_INFO;

type PACKET_BURST_INFO = record
   bigInvalidSlotCount: longint;
   bigForgedPacketCount: longint;
   bigInvalidPacketCount: longint;
   bigStillTransmittingCount: longint;
   stillDoingTheLastRequestCount: longint;
   invalidCtrlRequestCount: longint;
   ctrlInvalidMessageNumCount: longint;
   ctrlBeingTornDownCount: longint;
   bigRepeatTheFileReadCount: longint;
   bigSendExtraCCCount: longint;
   bigReturnAbortMessageCount: longint;
   bigReadInvalidMessageNumCount: longint;
   bigReadDoItOverCount: longint;
   bigReadBeingTornDownCount: longint;
   previousCtrlPacketCount: longint;
   sendHoldOffMessageCount: longint;
   bigReadNoDataAvailableCount: longint;
   bigReadTryingToReadTooMuchCount: longint;
   asyncReadErrorCount: longint;
   bigReadPhysicalReadErrorCount: longint;
   ctrlBadACKFragmentListCount: longint;
   ctrlNoDataReadCount: longint;
   writeDuplicateRequestCount: longint;
   shouldntBeACKingHereCount: longint;
   writeInconsistentPktLengthsCnt: longint;
   firstPacketIsntAWriteCount: longint;
   writeTrashedDuplicateRequestCnt: longint;
   bigWriteInvalidMessageNumCount: longint;
   bigWriteBeingTornDownCount: longint;
   bigWriteBeingAbortedCount: longint;
   zeroACKFragmentCountCount: longint;
   writeCurrentlyTransmittingCount: longint;
   tryingToWriteTooMuchCount: longint;
   writeOutOfMemForCtrlNodesCount: longint;
   writeDidntNeedThisFragmentCount: longint;
   writeTooManyBuffsCheckedOutCnt: longint;
   writeTimeOutCount: longint;
   writeGotAnACKCount: longint;
   writeGotAnACKCount1: longint;
   pollerAbortedTheConnCount: longint;
   maybeHadOutOfOrderWritesCount: longint;
   hadAnOutOfOrderWriteCount: longint;
   movedTheACKBitDownCount: longint;
   bumpedOutOfOrderWriteCount: longint;
   pollerRemovedOldOutOfOrderCount: longint;
   writeDidntNeedButRequestACKCnt: longint;
   writeTrashedPacketCount: longint;
   tooManyACKFragmentsCount: longint;
   savedAnOutOfOrderPacketCount: longint;
   connBeingAbortedCount: longint;
end;
type PPACKET_BURST_INFO = ^PACKET_BURST_INFO;

type NWFSE_PACKET_BURST_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   packetBurstInfo: PACKET_BURST_INFO;
end;
type PNWFSE_PACKET_BURST_INFO = ^NWFSE_PACKET_BURST_INFO;

type IPX_INFO = record
   IPXSendPacketCount: longint;
   IPXMalformPacketCount: word;
   IPXGetECBRequestCount: longint;
   IPXGetECBFailCount: longint;
   IPXAESEventCount: longint;
   IPXPostponedAESCount: word;
   IPXMaxConfiguredSocketCount: word;
   IPXMaxOpenSocketCount: word;
   IPXOpenSocketFailCount: word;
   IPXListenECBCount: longint;
   IPXECBCancelFailCount: word;
   IPXGetLocalTargetFailCount: word;
end;
type PIPX_INFO = ^IPX_INFO;

type SPX_INFO = record
   SPXMaxConnsCount: word;
   SPXMaxUsedConns: word;
   SPXEstConnReq: word;
   SPXEstConnFail: word;
   SPXListenConnectReq: word;
   SPXListenConnectFail: word;
   SPXSendCount: longint;
   SPXWindowChokeCount: longint;
   SPXBadSendCount: word;
   SPXSendFailCount: word;
   SPXAbortedConn: word;
   SPXListenPacketCount: longint;
   SPXBadListenCount: word;
   SPXIncomingPacketCount: longint;
   SPXBadInPacketCount: word;
   SPXSuppressedPackCount: word;
   SPXNoSesListenECBCount: word;
   SPXWatchDogDestSesCount: word;
end;
type PSPX_INFO = ^SPX_INFO;

type NWFSE_IPXSPX_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   IPXInfo: IPX_INFO;
   SPXInfo: SPX_INFO;
end;
type PNWFSE_IPXSPX_INFO = ^NWFSE_IPXSPX_INFO;

type NWFSE_GARBAGE_COLLECTION_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   failedAllocRequestCount: longint;
   numOfAllocs: longint;
   noMoreMemAvailableCount: longint;
   numOfGarbageCollections: longint;
   garbageFoundSomeMem: longint;
   garbageNumOfChecks: longint;
end;
type PNWFSE_GARBAGE_COLLECTION_INFO = ^NWFSE_GARBAGE_COLLECTION_INFO;

type CPU_INFO = record
   pageTableOwnerFlag: longint;
   CPUTypeFlag: longint;
   coProcessorFlag: longint;
   busTypeFlag: longint;
   IOEngineFlag: longint;
   FSEngineFlag: longint;
   nonDedicatedFlag: longint;
end;
type PCPU_INFO = ^CPU_INFO;

type NWFSE_CPU_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numOfCPUs: longint;
   CPUInfo: CPU_INFO;
end;
type PNWFSE_CPU_INFO = ^NWFSE_CPU_INFO;

type VOLUME_SWITCH_INFO = record
   readFile: longint;
   writeFile: longint;
   deleteFile: longint;
   renMove: longint;
   openFile: longint;
   createFile: longint;
   createAndOpenFile: longint;
   closeFile: longint;
   scanDeleteFile: longint;
   salvageFile: longint;
   purgeFile: longint;
   migrateFile: longint;
   deMigrateFile: longint;
   createDir: longint;
   deleteDir: longint;
   directoryScans: longint;
   mapPathToDirNum: longint;
   modifyDirEntry: longint;
   getAccessRights: longint;
   getAccessRightsFromIDs: longint;
   mapDirNumToPath: longint;
   getEntryFromPathStrBase: longint;
   getOtherNSEntry: longint;
   getExtDirInfo: longint;
   getParentDirNum: longint;
   addTrusteeR: longint;
   scanTrusteeR: longint;
   delTrusteeR: longint;
   purgeTrust: longint;
   findNextTrustRef: longint;
   scanUserRestNodes: longint;
   addUserRest: longint;
   deleteUserRest: longint;
   rtnDirSpaceRest: longint;
   getActualAvailDskSp: longint;
   cntOwnedFilesAndDirs: longint;
   migFileInfo: longint;
   volMigInfo: longint;
   readMigFileData: longint;
   getVolusageStats: longint;
   getActualVolUsageStats: longint;
   getDirUsageStats: longint;
   NMFileReadsCount: longint;
   NMFileWritesCount: longint;
   mapPathToDirNumOrPhantom: longint;
   stationHasAccessRgtsGntedBelow: longint;
   gtDataStreamLensFromPathStrBase: longint;
   checkAndGetDirectoryEntry: longint;
   getDeletedEntry: longint;
   getOriginalNameSpace: longint;
   getActualFileSize: longint;
   verifyNameSpaceNumber: longint;
   verifyDataStreamNumber: longint;
   checkVolumeNumber: longint;
   commitFile: longint;
   VMGetDirectoryEntry: longint;
   createDMFileEntry: longint;
   renameNameSpaceEntry: longint;
   logFile: longint;
   releaseFile: longint;
   clearFile: longint;
   setVolumeFlag: longint;
   clearVolumeFlag: longint;
   getOriginalInfo: longint;
   createMigratedDir: longint;
   F3OpenCreate: longint;
   F3InitFileSearch: longint;
   F3ContinueFileSearch: longint;
   F3RenameFile: longint;
   F3ScanForTrustees: longint;
   F3ObtainFileInfo: longint;
   F3ModifyInfo: longint;
   F3EraseFile: longint;
   F3SetDirHandle: longint;
   F3AddTrustees: longint;
   F3DeleteTrustees: longint;
   F3AllocDirHandle: longint;
   F3ScanSalvagedFiles: longint;
   F3RecoverSalvagedFiles: longint;
   F3PurgeSalvageableFile: longint;
   F3GetNSSpecificInfo: longint;
   F3ModifyNSSpecificInfo: longint;
   F3SearchSet: longint;
   F3GetDirBase: longint;
   F3QueryNameSpaceInfo: longint;
   F3GetNameSpaceList: longint;
   F3GetHugeInfo: longint;
   F3SetHugeInfo: longint;
   F3GetFullPathString: longint;
   F3GetEffectiveDirectoryRights: longint;
end;
type PVOLUME_SWITCH_INFO = ^VOLUME_SWITCH_INFO;

type NWFSE_VOLUME_SWITCH_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   totalLFSCounters: longint;
   CurrentLFSCounters: longint;
   LFSCounters: array [0..127] of longint;
end;
type PNWFSE_VOLUME_SWITCH_INFO = ^NWFSE_VOLUME_SWITCH_INFO;

type NWFSE_NLM_LOADED_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberNLMsLoaded: longint;
   NLMsInList: longint;
   NLMNums: array [0..127] of longint;
end;
type PNWFSE_NLM_LOADED_LIST = ^NWFSE_NLM_LOADED_LIST;

type NLM_INFO = record
   identificationNum: longint;
   flags: longint;
   _type: longint;
   parentID: longint;
   majorVersion: longint;
   minorVersion: longint;
   revision: longint;
   year: longint;
   month: longint;
   day: longint;
   allocAvailableBytes: longint;
   allocFreeCount: longint;
   lastGarbageCollection: longint;
   messageLanguage: longint;
   numOfReferencedPublics: longint;
end;
type PNLM_INFO = ^NLM_INFO;

type NWFSE_NLM_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   NLMInfo: NLM_INFO;
end;
type PNWFSE_NLM_INFO = ^NWFSE_NLM_INFO;

type DIR_CACHE_INFO = record
   minTimeSinceFileDelete: longint;
   absMinTimeSinceFileDelete: longint;
   minNumOfDirCacheBuffers: longint;
   maxNumOfDirCacheBuffers: longint;
   numOfDirCacheBuffers: longint;
   dCMinNonReferencedTime: longint;
   dCWaitTimeBeforeNewBuffer: longint;
   dCMaxConcurrentWrites: longint;
   dCDirtyWaitTime: longint;
   dCDoubleReadFlag: longint;
   mapHashNodeCount: longint;
   spaceRestrictionNodeCount: longint;
   trusteeListNodeCount: longint;
   percentOfVolumeUsedByDirs: longint;
end;
type PDIR_CACHE_INFO = ^DIR_CACHE_INFO;

type NWFSE_DIR_CACHE_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   dirCacheInfo: DIR_CACHE_INFO;
end;
type PNWFSE_DIR_CACHE_INFO = ^NWFSE_DIR_CACHE_INFO;

type NWFSE_OS_VERSION_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   OSMajorVersion: byte;
   OSMinorVersion: byte;
   OSRevisionNum: byte;
   accountingVersion: byte;
   VAPVersion: byte;
   queueingVersion: byte;
   securityRestrictionsLevel: byte;
   bridgingSupport: byte;
   maxNumOfVolumes: longint;
   numOfConnSlots: longint;
   maxLoggedInConns: longint;
   maxNumOfNameSpaces: longint;
   maxNumOfLans: longint;
   maxNumOfMediaTypes: longint;
   maxNumOfProtocols: longint;
   maxMaxSubdirTreeDepth: longint;
   maxNumOfDataStreams: longint;
   maxNumOfSpoolPrinters: longint;
   serialNum: longint;
   applicationNum: word;
end;
type PNWFSE_OS_VERSION_INFO = ^NWFSE_OS_VERSION_INFO;

type NWFSE_ACTIVE_CONN_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   activeConnBitList: array [0..511] of byte;
end;
type PNWFSE_ACTIVE_CONN_LIST = ^NWFSE_ACTIVE_CONN_LIST;

type NWFSE_NLMS_RESOURCE_TAG_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   totalNumOfResourceTags: longint;
   packetResourceTags: longint;
   resourceTagBuf: array [0..511] of byte;
end;
type PNWFSE_NLMS_RESOURCE_TAG_LIST = ^NWFSE_NLMS_RESOURCE_TAG_LIST;

type NWFSE_ACTIVE_LAN_BOARD_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   MaxNumOfLANs: longint;
   LANLoadedCount: longint;
   boardNums: array [0..63] of longint;
end;
type PNWFSE_ACTIVE_LAN_BOARD_LIST = ^NWFSE_ACTIVE_LAN_BOARD_LIST;

type LAN_CONFIG_INFO = record
   DriverCFG_MajorVersion: byte;
   DriverCFG_MinorVersion: byte;
   DriverNodeAddress: array [0..5] of byte;
   DriverModeFlags: word;
   DriverBoardNum: word;
   DriverBoardInstance: word;
   DriverMaxSize: longint;
   DriverMaxRecvSize: longint;
   DriverRecvSize: longint;
   Reserved1: array [0..2] of longint;
   DriverCardID: word;
   DriverMediaID: word;
   DriverTransportTime: word;
   DriverReserved: array [0..15] of byte;
   DriverMajorVersion: byte;
   DriverMinorVersion: byte;
   DriverFlags: word;
   DriverSendRetries: word;
   DriverLink: longint;
   DriverSharingFlags: word;
   DriverSlot: word;
   DriverIOPortsAndLengths: array [0..3] of word;
   DriverMemDecode0: longint;
   DriverLength0: word;
   DriverMemDecode1: longint;
   DriverLength1: word;
   DriverInterrupt: array [0..1] of byte;
   DriverDMAUsage: array [0..1] of byte;
   Reserved2: array [0..2] of longint;
   DriverLogicalName: array [0..17] of byte;
   DriverLinearMem: array [0..1] of longint;
   DriverChannelNum: word;
   DriverIOReserved: array [0..5] of byte;
end;
type PLAN_CONFIG_INFO = ^LAN_CONFIG_INFO;

type NWFSE_LAN_CONFIG_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   LANConfigInfo: LAN_CONFIG_INFO;
end;
type PNWFSE_LAN_CONFIG_INFO = ^NWFSE_LAN_CONFIG_INFO;

type LAN_COMMON_INFO = record
   notSupportedMask: longint;
   totalTxPAcketCount: longint;
   totalRxPacketCount: longint;
   noECBAvailableCount: longint;
   packetTxTooBigCount: longint;
   packetTxTooSmallCount: longint;
   packetRxOverflowCount: longint;
   packetRxTooBigCount: longint;
   packetRxTooSmallCount: longint;
   packetTxMiscErrorCount: longint;
   packetRxMiscErrorCount: longint;
   retryTxCount: longint;
   checksumErrorCount: longint;
   hardwareRxMismatchCount: longint;
   reserved: array [0..49] of longint;
end;
type PLAN_COMMON_INFO = ^LAN_COMMON_INFO;

type NWFSE_LAN_COMMON_COUNTERS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   statisticsMajorVersion: byte;
   statisticsMinorVersion: byte;
   numberOfGenericCounters: longint;
   numberOfCounterBlocks: longint;
   customVariableCount: longint;
   NextCounterBlock: longint;
   LANCommonInfo: LAN_COMMON_INFO;
end;
type PNWFSE_LAN_COMMON_COUNTERS_INFO = ^NWFSE_LAN_COMMON_COUNTERS_INFO;

type NWFSE_LAN_CUSTOM_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numCustomVar: longint;
   customInfo: array [0..511] of byte;
end;
type PNWFSE_LAN_CUSTOM_INFO = ^NWFSE_LAN_CUSTOM_INFO;

type LSL_INFO = record
   rxBufs: longint;
   rxBufs75PerCent: longint;
   rxBufsCheckedOut: longint;
   rxBufMaxSize: longint;
   maxPhysicalSize: longint;
   lastTimeRxBufAllocated: longint;
   maxNumsOfProtocols: longint;
   maxNumsOfMediaTypes: longint;
   totalTXPackets: longint;
   getECBBfrs: longint;
   getECBFails: longint;
   AESEventCounts: longint;
   postponedEvents: longint;
   ECBCxlFails: longint;
   validBfrsReused: longint;
   enqueuedSendCount: longint;
   totalRXPackets: longint;
   unclaimedPackets: longint;
   StatisticsTableMajorVersion: byte;
   StatisticsTableMinorVersion: byte;
end;
type PLSL_INFO = ^LSL_INFO;

type NWFSE_LSL_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   LSLInfo: LSL_INFO;
end;
type PNWFSE_LSL_INFO = ^NWFSE_LSL_INFO;

type NWFSE_LSL_LOGICAL_BOARD_STATS = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved0: word;
   LogTtlTxPackets: longint;
   LogTtlRxPackets: longint;
   LogUnclaimedPackets: longint;
   reserved1: longint;
end;
type PNWFSE_LSL_LOGICAL_BOARD_STATS = ^NWFSE_LSL_LOGICAL_BOARD_STATS;

type MEDIA_INFO_DEF = record
   _label: array [0..63] of byte;
   identificationtype: longint;
   identificationtimestamp: longint;
end;
type PMEDIA_INFO_DEF = ^MEDIA_INFO_DEF;

type FSE_MM_OBJ_INFO = record
   MediaInfo: MEDIA_INFO_DEF;
   mediaType: longint;
   cartridgeType: longint;
   unitSize: longint;
   blockSize: longint;
   capacity: longint;
   preferredUnitSize: longint;
   name: array [0..63] of byte;
   _type: longint;
   status: longint;
   functionMask: longint;
   controlMask: longint;
   parentCount: longint;
   siblingCount: longint;
   childCount: longint;
   specificInfoSize: longint;
   objectUniqueID: longint;
   mediaSlot: longint;
end;
type PFSE_MM_OBJ_INFO = ^FSE_MM_OBJ_INFO;

type NWFSE_MEDIA_MGR_OBJ_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   fseMMObjInfo: FSE_MM_OBJ_INFO;
end;
type PNWFSE_MEDIA_MGR_OBJ_INFO = ^NWFSE_MEDIA_MGR_OBJ_INFO;

type NWFSE_MEDIA_MGR_OBJ_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   nextStartObjNum: longint;
   objCount: longint;
   objs: array [0..127] of longint;
end;
type PNWFSE_MEDIA_MGR_OBJ_LIST = ^NWFSE_MEDIA_MGR_OBJ_LIST;

type VOLUME_SEGMENT = record
   volumeSegmentDeviceNum: longint;
   volumeSegmentOffset: longint;
   volumeSegmentSize: longint;
end;
type PVOLUME_SEGMENT = ^VOLUME_SEGMENT;

type NWFSE_VOLUME_SEGMENT_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numOfVolumeSegments: longint;
   volumeSegment: array [0..41] of VOLUME_SEGMENT;
end;
type PNWFSE_VOLUME_SEGMENT_LIST = ^NWFSE_VOLUME_SEGMENT_LIST;

type VOLUME_INFO_BY_LEVEL_DEF = record
   volumeType: longint;
   statusFlagBits: longint;
   sectorSize: longint;
   sectorsPerCluster: longint;
   volumeSizeInClusters: longint;
   freedClusters: longint;
   subAllocFreeableClusters: longint;
   freeableLimboSectors: longint;
   nonFreeableLimboSectors: longint;
   nonFreeableAvailSubAllocSectors: longint;
   notUsableSubAllocSectors: longint;
   subAllocClusters: longint;
   dataStreamsCount: longint;
   limboDataStreamsCount: longint;
   oldestDeletedFileAgeInTicks: longint;
   compressedDataStreamsCount: longint;
   compressedLimboDataStreamsCount: longint;
   unCompressableDataStreamsCount: longint;
   preCompressedSectors: longint;
   compressedSectors: longint;
   migratedFiles: longint;
   migratedSectors: longint;
   clustersUsedByFAT: longint;
   clustersUsedByDirectories: longint;
   clustersUsedByExtendedDirs: longint;
   totalDirectoryEntries: longint;
   unUsedDirectoryEntries: longint;
   totalExtendedDirectoryExtants: longint;
   unUsedExtendedDirectoryExtants: longint;
   extendedAttributesDefined: longint;
   extendedAttributeExtantsUsed: longint;
   directoryServicesObjectID: longint;
   volumeLastModifiedDateAndTime: longint;
end;
type PVOLUME_INFO_BY_LEVEL_DEF = ^VOLUME_INFO_BY_LEVEL_DEF;

type VOLUME_INFO_BY_LEVEL_DEF2 = record
   volumeActiveCount: longint;
   volumeUseCount: longint;
   mACRootIDs: longint;
   volumeLastModifiedDateAndTime: longint;
   volumeReferenceCount: longint;
   compressionLowerLimit: longint;
   outstandingIOs: longint;
   outstandingCompressionIOs: longint;
   compressionIOsLimit: longint;
end;
type PVOLUME_INFO_BY_LEVEL_DEF2 = ^VOLUME_INFO_BY_LEVEL_DEF2;


type
PVOLUME_INFO_BY_LEVEL = ^VOLUME_INFO_BY_LEVEL;
VOLUME_INFO_BY_LEVEL = record
case integer of
   0: (volInfoDef: VOLUME_INFO_BY_LEVEL_DEF);
   1: (volInfoDef2: VOLUME_INFO_BY_LEVEL_DEF2);
end;

type NWFSE_VOLUME_INFO_BY_LEVEL = record
   serverAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   infoLevel: longint;
   volumeInfo: VOLUME_INFO_BY_LEVEL;
end;
type PNWFSE_VOLUME_INFO_BY_LEVEL = ^NWFSE_VOLUME_INFO_BY_LEVEL;

type STACK_INFO = record
   StackNum: longint;
   StackShortName: array [0..15] of byte;
end;
type PSTACK_INFO = ^STACK_INFO;

type NWFSE_ACTIVE_STACKS = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   maxNumOfStacks: longint;
   stackCount: longint;
   nextStartNum: longint;
   stackInfo: array [0..24] of STACK_INFO;
end;
type PNWFSE_ACTIVE_STACKS = ^NWFSE_ACTIVE_STACKS;

type NWFSE_PROTOCOL_STK_CONFIG_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   configMajorVersionNum: byte;
   configMinorVersionNum: byte;
   stackMajorVersionNum: byte;
   stackMinorVersionNum: byte;
   stackShortName: array [0..15] of byte;
end;
type PNWFSE_PROTOCOL_STK_CONFIG_INFO = ^NWFSE_PROTOCOL_STK_CONFIG_INFO;

type NWFSE_PROTOCOL_STK_STATS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   statMajorVersionNum: byte;
   statMinorVersionNum: byte;
   commonCounters: word;
   validCountersMask: longint;
   totalTxPackets: longint;
   totalRxPackets: longint;
   ignoredRxPackets: longint;
   numCustomCounters: word;
end;
type PNWFSE_PROTOCOL_STK_STATS_INFO = ^NWFSE_PROTOCOL_STK_STATS_INFO;

type NWFSE_PROTOCOL_CUSTOM_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved0: word;
   customCount: longint;
   customStruct: array [0..511] of byte;
end;
type PNWFSE_PROTOCOL_CUSTOM_INFO = ^NWFSE_PROTOCOL_CUSTOM_INFO;

type NWFSE_PROTOCOL_ID_NUMS = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   stackIDCount: longint;
   stackIDs: array [0..127] of longint;
end;
type PNWFSE_PROTOCOL_ID_NUMS = ^NWFSE_PROTOCOL_ID_NUMS;

type NWFSE_MEDIA_NAME_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
end;
type PNWFSE_MEDIA_NAME_LIST = ^NWFSE_MEDIA_NAME_LIST;

type NWFSE_LOADED_MEDIA_NUM_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   maxMediaTypes: longint;
   mediaListCount: longint;
   mediaList: array [0..31] of longint;
end;
type PNWFSE_LOADED_MEDIA_NUM_LIST = ^NWFSE_LOADED_MEDIA_NUM_LIST;

type NWFSE_GENERAL_ROUTER_SAP_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   internalRIPSocket: longint;
   internalRouterDownFlag: longint;
   trackOnFlag: longint;
   externalRouterActiveFlag: longint;
   internalSAPSocketNumber: longint;
   replyToNearestServerFlag: longint;
end;
type PNWFSE_GENERAL_ROUTER_SAP_INFO = ^NWFSE_GENERAL_ROUTER_SAP_INFO;

type NWFSE_NETWORK_ROUTER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   NetIDNumber: longint;
   HopsToNet: word;
   NetStatus: word;
   TimeToNet: word;
end;
type PNWFSE_NETWORK_ROUTER_INFO = ^NWFSE_NETWORK_ROUTER_INFO;

type ROUTERS_INFO = record
   nodeAddress: array [0..5] of byte;
   connectedLAN: longint;
   routeHops: word;
   routeTime: word;
end;
type PROUTERS_INFO = ^ROUTERS_INFO;

type NWFSE_NETWORK_ROUTERS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   NumberOfEntries: longint;
   routersInfo: array [0..35] of ROUTERS_INFO;
end;
type PNWFSE_NETWORK_ROUTERS_INFO = ^NWFSE_NETWORK_ROUTERS_INFO;

type KNOWN_NET_INFO = record
   netIDNumber: longint;
   hopsToNet: word;
   netStatus: word;
   timeToNet: word;
end;
type PKNOWN_NET_INFO = ^KNOWN_NET_INFO;

type NWFSE_KNOWN_NETWORKS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfEntries: longint;
   knownNetInfo: array [0..50] of KNOWN_NET_INFO;
end;
type PNWFSE_KNOWN_NETWORKS_INFO = ^NWFSE_KNOWN_NETWORKS_INFO;

type NWFSE_SERVER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   serverAddress: array [0..11] of byte;
   hopsToServer: word;
end;
type PNWFSE_SERVER_INFO = ^NWFSE_SERVER_INFO;

type SERVERS_SRC_INFO = record
   serverNode: array [0..5] of byte;
   connectedLAN: longint;
   sourceHops: word;
end;
type PSERVERS_SRC_INFO = ^SERVERS_SRC_INFO;

type NWFSE_SERVER_SRC_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfEntries: longint;
   serversSrcInfo: array [0..41] of SERVERS_SRC_INFO;
end;
type PNWFSE_SERVER_SRC_INFO = ^NWFSE_SERVER_SRC_INFO;

type NWFSE_KNOWN_SERVER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfEntries: longint;
   data: array [0..511] of byte;
end;
type PNWFSE_KNOWN_SERVER_INFO = ^NWFSE_KNOWN_SERVER_INFO;

type NWFSE_SERVER_SET_CMDS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfSetCommands: longint;
   nextSequenceNumber: longint;
   setCmdType: longint;
   setCmdCategory: longint;
   setCmdFlags: longint;
   setNameAndValueInfo: array [0..499] of byte;
end;
type PNWFSE_SERVER_SET_CMDS_INFO = ^NWFSE_SERVER_SET_CMDS_INFO;

type NWFSE_SERVER_SET_CATEGORIES = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfSetCategories: longint;
   nextSequenceNumber: longint;
   categoryName: array [0..511] of byte;
end;
type PNWFSE_SERVER_SET_CATEGORIES = ^NWFSE_SERVER_SET_CATEGORIES;}

type
PNW_AFP_FILE_INFO = ^NW_AFP_FILE_INFO;
NW_AFP_FILE_INFO = record
   entryID: longint;
   parentID: longint;
   attributes: word;
   dataForkLength: longint;
   resourceForkLength: longint;
   numOffspring: word;
   creationDate: word;
   accessDate: word;
   modifyDate: word;
   modifyTime: word;
   backupDate: word;
   backupTime: word;
   finderInfo: array [0..31] of byte;
   longName: array [0..33] of char;
   ownerID: longint;
   shortName: array [0..13] of char;
   accessPrivileges: word;
   proDOSInfo: array [0..5] of byte;
end;

type 
PNW_AFP_SET_INFO= ^NW_AFP_SET_INFO;
NW_AFP_SET_INFO = record
   attributes: word;
   creationDate: word;
   accessDate: word;
   modifyDate: word;
   modifyTime: word;
   backupDate: word;
   backupTime: word;
   finderInfo: array [0..31] of byte;
   proDOSInfo: array [0..5] of byte;
end;

type 
PCONN_USE= ^CONN_USE;
CONN_USE = record
   systemElapsedTime: longint;
   bytesRead: array [0..5] of byte;
   bytesWritten: array [0..5] of byte;
   totalRequestPackets: longint;
end;

type 
PNWINET_ADDR = ^NWINET_ADDR;
NWINET_ADDR = record
   networkAddr: array [0..3] of byte;
   netNodeAddr: array [0..5] of byte;
   socket: word;
   connType: word;
end;

type 
PCONNECT_INFO = ^CONNECT_INFO;
CONNECT_INFO = record
   connID: word;
   connectFlags: word;
   sessionID: word;
   connNumber: word;
   serverAddr: array [0..11] of byte;
   serverType: word;
   serverName: array [0..47] of char;
   clientType: word;
   clientName: array [0..47] of char;
end;

type 
PNWDELETED_INFO = ^NWDELETED_INFO;
NWDELETED_INFO = record
   sequence: longint;
   parent: longint;
   attributes: longint;
   uniqueID: byte;
   flags: byte;
   nameSpace: byte;
   nameLength: byte;
   name: array [0..255] of byte;
   creationDateAndTime: longint;
   ownerID: longint;
   lastArchiveDateAndTime: longint;
   lastArchiverID: longint;
   updateDateAndTime: longint;
   updatorID: longint;
   fileSize: longint;
   reserved: array [0..43] of byte;
   inheritedRightsMask: word;
   lastAccessDate: word;
   deletedTime: longint;
   deletedDateAndTime: longint;
   deletorID: longint;
   reserved3: array [0..15] of byte;
end;

type 
PTRUSTEE_INFO = ^TRUSTEE_INFO;
TRUSTEE_INFO = record
   objectID: longint;
   objectRights: word;
end;

type 
PDIR_SPACE_INFO = ^DIR_SPACE_INFO;
DIR_SPACE_INFO = record
   totalBlocks: longint;
   availableBlocks: longint;
   purgeableBlocks: longint;
   notYetPurgeableBlocks: longint;
   totalDirEntries: longint;
   availableDirEntries: longint;
   reserved: longint;
   sectorsPerBlock: byte;
   volLen: byte;
   volName: array [0..16] of byte;
end;

type 
PNWFILE_INFO = ^NWFILE_INFO;
NWFILE_INFO = record
   updateDateAndTime: longint;
   updatorID: longint;
   fileSize: longint;
   reserved: array [0..43] of byte;
   inheritedRightsMask: word;
   lastAccessDate: word;
   reserved2: array [0..27] of byte;
end;

type 
PNWDIR_INFO = ^NWDIR_INFO;
NWDIR_INFO = record
   lastModifyDateAndTime: longint;
   nextTrusteeEntry: longint;
   reserved: array [0..47] of byte;
   maximumSpace: longint;
   inheritedRightsMask: word;
   reserved2: array [0..13] of byte;
   volObjectID: longint;
   reserved3: array [0..7] of byte;
end;

type
PNWENTRY_INFO = ^NWENTRY_INFO;
NWENTRY_INFO = record
   sequence: longint;
   parent: longint;
   attributes: longint;
   uniqueID: byte;
   flags: byte;
   nameSpace: byte;
   nameLength: byte;
   name: array [0..11] of byte;
   creationDateAndTime: longint;
   ownerID: longint;
   lastArchiveDateAndTime: longint;
   lastArchiverID: longint;
   info: record
case integer of
   0: (_file: NWFILE_INFO);
   1: (dir: NWDIR_INFO);
end;
end;

type 
PNWET_INFO = ^NWET_INFO;
NWET_INFO = record
   entryName: array [0..15] of char;
   creationDateAndTime: longint;
   ownerID: longint;
   sequenceNumber: longint;
   trusteeList: array [0..19] of TRUSTEE_INFO;
end;

type 
PNW_EXT_FILE_INFO = ^NW_EXT_FILE_INFO;
NW_EXT_FILE_INFO = record
   sequence: longint;
   parent: longint;
   attributes: longint;
   uniqueID: byte;
   flags: byte;
   nameSpace: byte;
   nameLength: byte;
   name: array [0..11] of byte;
   creationDateAndTime: longint;
   ownerID: longint;
   lastArchiveDateAndTime: longint;
   lastArchiverID: longint;
   updateDateAndTime: longint;
   lastUpdatorID: longint;
   dataForkSize: longint;
   dataForkFirstFAT: longint;
   nextTrusteeEntry: longint;
   reserved: array [0..35] of byte;
   inheritedRightsMask: word;
   lastAccessDate: word;
   deletedFileTime: longint;
   deletedDateAndTime: longint;
   deletorID: longint;
   reserved2: array [0..15] of byte;
   otherForkSize: array [0..1] of longint;
end;

type 
PNW_IDX = ^NW_IDX;
NW_IDX = record
   volNumber: byte;
   srcNameSpace: byte;
   srcDirBase: longint;
   dstNameSpace: byte;
   dstDirBase: longint;
end;

type 
PSEARCH_SEQUENCE = ^SEARCH_SEQUENCE;
SEARCH_SEQUENCE = record
   volNumber: byte;
   dirNumber: longint;
   searchDirNumber: longint;
end;

type 
PNW_ENTRY_INFO = ^NW_ENTRY_INFO;
NW_ENTRY_INFO = record
   spaceAlloc: longint;
   attributes: longint;
   flags: word;
   dataStreamSize: longint;
   totalStreamSize: longint;
   numberOfStreams: word;
   creationTime: word;
   creationDate: word;
   creatorID: longint;
   modifyTime: word;
   modifyDate: word;
   modifierID: longint;
   lastAccessDate: word;
   archiveTime: word;
   archiveDate: word;
   archiverID: longint;
   inheritedRightsMask: word;
   dirEntNum: longint;
   DosDirNum: longint;
   volNumber: longint;
   EADataSize: longint;
   EAKeyCount: longint;
   EAKeySize: longint;
   NSCreator: longint;
   nameLength: byte;
   entryName: array [0..255] of byte;
end;

type 
PNW_NS_OPEN = ^NW_NS_OPEN;
NW_NS_OPEN = record
   openCreateMode: byte;
   searchAttributes: word;
   reserved: longint;
   createAttributes: longint;
   accessRights: word;
   NetWareHandle: longint;
   openCreateAction: byte;
end;
type 
PNW_NS_OPENCREATE = ^NW_NS_OPENCREATE;
NW_NS_OPENCREATE = NW_NS_OPEN;


type 
PNW_NS_INFO = ^NW_NS_INFO;
NW_NS_INFO = record
   NSInfoBitMask: longint;
   fixedBitMask: longint;
   reservedBitMask: longint;
   extendedBitMask: longint;
   fixedBitsDefined: word;
   reservedBitsDefined: word;
   extendedBitsDefined: word;
   fieldsLenTable: array [0..31] of longint;
   hugeStateInfo: array [0..15] of byte;
   hugeDataLength: longint;
end;

type 
PNW_NS_PATH = ^NW_NS_PATH;
NW_NS_PATH = record
   srcPath: Pchar;
   dstPath: Pchar;
   dstPathSize: word;
end;

type 
PMODIFY_DOS_INFO = ^MODIFY_DOS_INFO;
MODIFY_DOS_INFO = record
   attributes: longint;
   createDate: word;
   createTime: word;
   creatorID: longint;
   modifyDate: word;
   modifyTime: word;
   modifierID: longint;
   archiveDate: word;
   archiveTime: word;
   archiverID: longint;
   lastAccessDate: word;
   inheritanceGrantMask: word;
   inheritanceRevokeMask: word;
   maximumSpace: longint;
end;

type 
PNW_EA_HANDLE = ^NW_EA_HANDLE;
NW_EA_HANDLE = record
   connID: word;
   rwPosition: longint;
   EAHandle: longint;
   volNumber: longint;
   dirBase: longint;
   keyUsed: byte;
   keyLength: word;
   key: array [0..255] of byte;
end;

type 
PNW_EA_FF_STRUCT = ^NW_EA_FF_STRUCT;
NW_EA_FF_STRUCT = record
   connID: word;
   nextKeyOffset: word;
   nextKey: word;
   numKeysRead: longint;
   totalKeys: longint;
   EAHandle: longint;
   sequence: word;
   numKeysInBuffer: word;
   enumBuffer: array [0..511] of byte;
end;

type 
PNW_FILE_INFO = ^NW_FILE_INFO;
NW_FILE_INFO = record
   fileName: array [0..13] of char;
   fileAttributes: byte;
   extendedFileAttributes: byte;
   fileSize: longint;
   creationDate: word;
   lastAccessDate: word;
   lastUpdateDateAndTime: longint;
   fileOwnerID: longint;
   lastArchiveDateAndTime: longint;
end;

type 
PNW_FILE_INFO2 = ^NW_FILE_INFO2;
NW_FILE_INFO2 = record
   fileAttributes: byte;
   extendedFileAttributes: byte;
   fileSize: longint;
   creationDate: word;
   lastAccessDate: word;
   lastUpdateDateAndTime: longint;
   fileOwnerID: longint;
   lastArchiveDateAndTime: longint;
   fileName: array [0..259] of char;
end;

type 
PCONN_USING_FILE = ^CONN_USING_FILE;
CONN_USING_FILE = record
   connNumber: word;
   taskNumber: word;
   lockType: byte;
   accessControl: byte;
   lockFlag: byte;
end;

type 
PCONNS_USING_FILE = ^CONNS_USING_FILE;
CONNS_USING_FILE = record
   nextRequest: word;
   useCount: word;
   openCount: word;
   openForReadCount: word;
   openForWriteCount: word;
   denyReadCount: word;
   denyWriteCount: word;
   locked: byte;
   forkCount: byte;
   connCount: word;
   connInfo: array [0..69] of CONN_USING_FILE;
end;

type 
POPEN_FILE_CONN_CTRL = ^OPEN_FILE_CONN_CTRL;
OPEN_FILE_CONN_CTRL = record
   nextRequest: word;
   openCount: word;
   buffer: array [0..511] of byte;
   curRecord: word;
end;

type 
POPEN_FILE_CONN = ^OPEN_FILE_CONN;
OPEN_FILE_CONN = record
   taskNumber: word;
   lockType: byte;
   accessControl: byte;
   lockFlag: byte;
   volNumber: byte;
   parent: longint;
   dirEntry: longint;
   forkCount: byte;
   nameSpace: byte;
   nameLen: byte;
   fileName: array [0..254] of char;
end;

type 
PCONN_OPEN_FILE = ^CONN_OPEN_FILE;
CONN_OPEN_FILE = record
   taskNumber: byte;
   lockType: byte;
   accessControl: byte;
   lockFlag: byte;
   volNumber: byte;
   dirEntry: word;
   fileName: array [0..13] of char;
end;

type 
PCONN_OPEN_FILES = ^CONN_OPEN_FILES;
CONN_OPEN_FILES = record
   nextRequest: word;
   connCount: byte;
   connInfo: array [0..21] of CONN_OPEN_FILE;
end;

type 
PNW_DATE = ^NW_DATE;
NW_DATE = record
   day: byte;
   month: byte;
   year: word;
end;

type 
PNW_TIME = ^NW_TIME;
NW_TIME = record
   seconds: byte;
   minutes: byte;
   hours: word;
end;

type 
PNW_FRAGMENT = ^NW_FRAGMENT;
NW_FRAGMENT = record
   fragAddress: pointer;
   fragSize: word;
end;

type 
PNW_REQUESTER_TYPE = ^NW_REQUESTER_TYPE;
NW_REQUESTER_TYPE = (
NW_LONG_NAME_REQUESTER,
NW_SHORT_NAME_REQUESTER,
NW_ERROR_ON_REQUESTER_TYPE
);

type 
PDIR_ENTRY = ^DIR_ENTRY;
DIR_ENTRY = record
   volNumber: byte;
   dirEntry: longint;
end;

type 
PCONN_TASK = ^CONN_TASK;
CONN_TASK = record
   taskNumber: word;
   taskState: byte;
end;

type 
PCONN_TASK_INFO = ^CONN_TASK_INFO;
CONN_TASK_INFO = record
   serverVersion: word;
   lockState: byte;
   waitingTaskNumber: word;
   recordStart: longint;
   recordEnd: longint;
   volNumber: byte;
   dirEntry: longint;
   nameSpace: byte;
   dirID: word;
   lockedName: array [0..255] of char;
   taskCount: byte;
   tasks: array [0..255] of CONN_TASK;
end;

type 
PPRINTER_STATUS = ^PRINTER_STATUS;
PRINTER_STATUS = record
   printerHalted: byte;
   printerOffline: byte;
   currentFormType: byte;
   redirectedPrinter: byte;
end;

type 
PNWCAPTURE_FLAGSRW = ^NWCAPTURE_FLAGSRW;
NWCAPTURE_FLAGSRW = record
   jobDescription: array [0..49] of byte;
   jobControlFlags: byte;
   tabSize: byte;
   numCopies: word;
   printFlags: word;
   maxLines: word;
   maxChars: word;
   formName: array [0..12] of byte;
   reserved: array [0..8] of byte;
   formType: word;
   bannerText: array [0..12] of byte;
   reserved2: byte;
   flushCaptureTimeout: word;
   flushCaptureOnClose: byte;
end;

type 
PNWCAPTURE_FLAGSRO = ^NWCAPTURE_FLAGSRO;
NWCAPTURE_FLAGSRO = record
   connID: word;
   queueID: longint;
   setupStringMaxLen: word;
   resetStringMaxLen: word;
   LPTCaptureFlag: byte;
   fileCaptureFlag: byte;
   timingOutFlag: byte;
   inProgress: byte;
   printQueueFlag: byte;
   printJobValid: byte;
   queueName: array [0..64] of char;
end;

type 
PNWPrintJobStruct = ^NWPrintJobStruct;
NWPrintJobStruct = record
   clientStation: longint;
   clientTask: longint;
   clientID: longint;
   targetServerID: longint;
   targetExecutionTime: array [0..5] of byte;
   jobEntryTime: array [0..5] of byte;
   jobNumber: longint;
   formType: word;
   jobPosition: word;
   jobControlFlags: word;
   jobFileName: array [0..13] of byte;
   jobFileHandle: longint;
   servicingServerStation: longint;
   servicingServerTask: longint;
   servicingServerID: longint;
   jobDescription: array [0..49] of byte;
   clientJobInfoVer: byte;
   tabSize: byte;
   numberCopies: word;
   printFlags: word;
   maxLines: word;
   maxChars: word;
   formName: array [0..15] of byte;
   reserved: array [0..5] of byte;
   bannerUserName: array [0..12] of byte;
   bannerFileName: array [0..12] of byte;
   bannerHeaderFileName: array [0..13] of byte;
   filePathName: array [0..79] of byte;
end;

type 
PQueueJobStruct = ^QueueJobStruct;
QueueJobStruct = record
   clientStation: byte;
   clientTask: byte;
   clientID: longint;
   targetServerID: longint;
   targetExecutionTime: array [0..5] of byte;
   jobEntryTime: array [0..5] of byte;
   jobNumber: word;
   jobType: word;
   jobPosition: byte;
   jobControlFlags: byte;
   jobFileName: array [0..13] of byte;
   jobFileHandle: array [0..5] of byte;
   servicingServerStation: byte;
   servicingServerTask: byte;
   servicingServerID: longint;
   jobDescription: array [0..49] of byte;
   clientRecordArea: array [0..151] of byte;
end;

type 
PNWQueueJobStruct = ^NWQueueJobStruct;
NWQueueJobStruct = record
   clientStation: longint;
   clientTask: longint;
   clientID: longint;
   targetServerID: longint;
   targetExecutionTime: array [0..5] of byte;
   jobEntryTime: array [0..5] of byte;
   jobNumber: longint;
   jobType: word;
   jobPosition: word;
   jobControlFlags: word;
   jobFileName: array [0..13] of byte;
   jobFileHandle: longint;
   servicingServerStation: longint;
   servicingServerTask: longint;
   servicingServerID: longint;
   jobDescription: array [0..49] of byte;
   clientRecordArea: array [0..151] of byte;
end;

type 
PQueueJobListReply = ^QueueJobListReply;
QueueJobListReply = record
   totalQueueJobs: longint;
   replyQueueJobNumbers: longint;
   jobNumberList: array [0..249] of longint;
end;

type 
PPHYS_DSK_STATS = ^PHYS_DSK_STATS;
PHYS_DSK_STATS = record
   systemElapsedTime: longint;
   diskChannel: byte;
   diskRemovable: byte;
   driveType: byte;
   controllerDriveNumber: byte;
   controllerNumber: byte;
   controllerType: byte;
   driveSize: longint;
   driveCylinders: word;
   driveHeads: byte;
   sectorsPerTrack: byte;
   driveDefinition: array [0..63] of byte;
   IOErrorCount: word;
   hotFixStart: longint;
   hotFixSize: word;
   hotFixBlockAvailable: word;
   hotFixDisabled: byte;
end;

type 
PFILESYS_STATS = ^FILESYS_STATS;
FILESYS_STATS = record
   systemElapsedTime: longint;
   maxOpenFiles: word;
   maxFilesOpened: word;
   currOpenFiles: word;
   totalFilesOpened: longint;
   totalReadRequests: longint;
   totalWriteRequests: longint;
   currChangedFATSectors: word;
   totalChangedFATSectors: longint;
   FATWriteErrors: word;
   fatalFATWriteErrors: word;
   FATScanErrors: word;
   maxIndexFilesOpened: word;
   currOpenIndexedFiles: word;
   attachedIndexFiles: word;
   availableIndexFiles: word;
end;

type 
PDSK_CHANNEL_STATS = ^DSK_CHANNEL_STATS;
DSK_CHANNEL_STATS = record
   systemElapsedTime: longint;
   channelState: word;
   channelSyncState: word;
   driverType: byte;
   driverMajorVersion: byte;
   driverMinorVersion: byte;
   driverDescription: array [0..64] of byte;
   IOAddr1: word;
   IOAddr1Size: word;
   IOAddr2: word;
   IOAddr2Size: word;
   sharedMem1Seg: array [0..2] of byte;
   sharedMem1Ofs: word;
   sharedMem2Seg: array [0..2] of byte;
   sharedMem2Ofs: word;
   interrupt1Used: byte;
   interrupt1: byte;
   interrupt2Used: byte;
   interrupt2: byte;
   DMAChannel1Used: byte;
   DMAChannel1: byte;
   DMAChannel2Used: byte;
   DMAChannel2: byte;
   reserved2: word;
   configDescription: array [0..79] of byte;
end;

type 
PDSK_CACHE_STATS = ^DSK_CACHE_STATS;
DSK_CACHE_STATS = record
   systemElapsedTime: longint;
   cacheBufferCount: word;
   cacheBufferSize: word;
   dirtyCacheBuffers: word;
   cacheReadRequests: longint;
   cacheWriteRequests: longint;
   cacheHits: longint;
   cacheMisses: longint;
   physicalReadRequests: longint;
   physicalWriteRequests: longint;
   physicalReadErrors: word;
   physicalWriteErrors: word;
   cacheGetRequests: longint;
   cacheFullWriteRequests: longint;
   cachePartialWriteRequests: longint;
   backgroundDirtyWrites: longint;
   backgroundAgedWrites: longint;
   totalCacheWrites: longint;
   cacheAllocations: longint;
   thrashingCount: word;
   LRUBlockWasDirtyCount: word;
   readBeyondWriteCount: word;
   fragmentedWriteCount: word;
   cacheHitOnUnavailCount: word;
   cacheBlockScrappedCount: word;
end;

type 
PDRV_MAP_TABLE = ^DRV_MAP_TABLE;
DRV_MAP_TABLE = record
   systemElapsedTime: longint;
   SFTSupportLevel: byte;
   logicalDriveCount: byte;
   physicalDriveCount: byte;
   diskChannelTable: array [0..4] of byte;
   pendingIOCommands: word;
   driveMappingTable: array [0..31] of byte;
   driveMirrorTable: array [0..31] of byte;
   deadMirrorTable: array [0..31] of byte;
   reMirrorDriveNumber: byte;
   reserved: byte;
   reMirrorCurrentOffset: longint;
   SFTErrorTable: array [0..59] of word;
end;

type 
PNWLAN_CONFIG = ^NWLAN_CONFIG;
NWLAN_CONFIG = record
   networdAddress: array [0..3] of byte;
   hostAddress: array [0..5] of byte;
   boardInstalled: byte;
   optionNumber: byte;
   configurationText1: array [0..79] of byte;
   configurationText2: array [0..79] of byte;
end;

type 
PSERVER_LAN_IO_STATS = ^SERVER_LAN_IO_STATS;
SERVER_LAN_IO_STATS = record
   systemElapsedTime: longint;
   maxRoutingBuffersAvail: word;
   maxRoutingBuffersUsed: word;
   routingBuffersInUse: word;
   totalFileServicePackets: longint;
   fileServicePacketsBuffered: word;
   invalidConnPacketCount: word;
   badLogicalConnCount: word;
   packetsRcvdDuringProcCount: word;
   reprocessedRequestCount: word;
   badSequenceNumberPacketCount: word;
   duplicateReplyCount: word;
   acknowledgementsSent: word;
   badRequestTypeCount: word;
   attachDuringProcCount: word;
   attachWhileAttachingCount: word;
   forgedDetachRequestCount: word;
   badConnNumberOnDetachCount: word;
   detachDuringProcCount: word;
   repliesCanceledCount: word;
   hopCountDiscardCount: word;
   unknownNetDiscardCount: word;
   noDGroupBufferDiscardCount: word;
   outPacketNoBufferDiscardCount: word;
   IPXNotMyNetworkCount: word;
   NetBIOSPropagationCount: longint;
   totalOtherPackets: longint;
   totalRoutedPackets: longint;
end;

type 
PVERSION_INFO = ^VERSION_INFO;
VERSION_INFO = record
   serverName: array [0..47] of byte;
   fileServiceVersion: byte;
   fileServiceSubVersion: byte;
   maximumServiceConnections: word;
   connectionsInUse: word;
   maxNumberVolumes: word;
   revision: byte;
   SFTLevel: byte;
   TTSLevel: byte;
   maxConnectionsEverUsed: word;
   accountVersion: byte;
   VAPVersion: byte;
   queueVersion: byte;
   printVersion: byte;
   virtualConsoleVersion: byte;
   restrictionLevel: byte;
   internetBridge: byte;
   reserved: array [0..59] of byte;
end;

type 
PNW_DYNAMIC_MEM = ^NW_DYNAMIC_MEM;
NW_DYNAMIC_MEM = record
   total: longint;
   max: longint;
   cur: longint;
end;

type 
PNW_FS_INFO = ^NW_FS_INFO;
NW_FS_INFO = record
   upTime: longint;
   processor: byte;
   reserved: byte;
   numProcs: byte;
   utilization: byte;
   configuredObjs: word;
   maxObjs: word;
   curObjs: word;
   totalMem: word;
   unusedMem: word;
   numMemAreas: word;
   dynamicMem: array [0..2] of NW_DYNAMIC_MEM;
end;

type 
PPHYSICAL_LOCK = ^PHYSICAL_LOCK;
PHYSICAL_LOCK = record
   loggedCount: word;
   shareableLockCount: word;
   recordStart: longint;
   recordEnd: longint;
   connNumber: word;
   taskNumber: word;
   lockType: byte;
end;

type 
PPHYSICAL_LOCKS = ^PHYSICAL_LOCKS;
PHYSICAL_LOCKS = record
   nextRequest: word;
   numRecords: word;
   locks: array [0..31] of PHYSICAL_LOCK;
   curRecord: word;
   reserved: array [0..7] of byte;
end;

type 
PCONN_PHYSICAL_LOCK = ^CONN_PHYSICAL_LOCK;
CONN_PHYSICAL_LOCK = record
   taskNumber: word;
   lockType: byte;
   recordStart: longint;
   recordEnd: longint;
end;

type 
PCONN_PHYSICAL_LOCKS = ^CONN_PHYSICAL_LOCKS;
CONN_PHYSICAL_LOCKS = record
   nextRequest: word;
   numRecords: word;
   locks: array [0..50] of CONN_PHYSICAL_LOCK;
   curRecord: word;
   reserved: array [0..21] of byte;
end;

type 
PCONN_LOGICAL_LOCKS = ^CONN_LOGICAL_LOCKS;
CONN_LOGICAL_LOCKS = record
   nextRequest: word;
   numRecords: word;
   records: array [0..507] of byte;
   curOffset: word;
   curRecord: word;
end;

type 
PCONN_LOGICAL_LOCK = ^CONN_LOGICAL_LOCK;
CONN_LOGICAL_LOCK = record
   taskNumber: word;
   lockStatus: byte;
   logicalName: array [0..127] of char;
end;

type 
PLOGICAL_LOCK = ^LOGICAL_LOCK;
LOGICAL_LOCK = record
   connNumber: word;
   taskNumber: word;
   lockStatus: byte;
end;

type 
PLOGICAL_LOCKS = ^LOGICAL_LOCKS;
LOGICAL_LOCKS = record
   useCount: word;
   shareableLockCount: word;
   locked: byte;
   nextRequest: word;
   numRecords: word;
   logicalLock: array [0..127] of LOGICAL_LOCK;
   curRecord: word;
end;

type 
PSEMAPHORE = ^SEMAPHORE;
SEMAPHORE = record
   connNumber: word;
   taskNumber: word;
end;

type 
PSEMAPHORES = ^SEMAPHORES;
SEMAPHORES = record
   nextRequest: word;
   openCount: word;
   semaphoreValue: word;
   semaphoreCount: word;
   semaphores: array [0..169] of SEMAPHORE;
   curRecord: word;
end;

type 
PCONN_SEMAPHORE = ^CONN_SEMAPHORE;
CONN_SEMAPHORE = record
   openCount: word;
   semaphoreValue: word;
   taskNumber: word;
   semaphoreName: array [0..127] of char;
end;

type 
PCONN_SEMAPHORES = ^CONN_SEMAPHORES;
CONN_SEMAPHORES = record
   nextRequest: word;
   numRecords: word;
   records: array [0..507] of byte;
   curOffset: word;
   curRecord: word;
end;

type 
PTTS_STATS = ^TTS_STATS;
TTS_STATS = record
   systemElapsedTime: longint;
   TTS_Supported: byte;
   TTS_Enabled: byte;
   TTS_VolumeNumber: word;
   TTS_MaxOpenTransactions: word;
   TTS_MaxTransactionsOpened: word;
   TTS_CurrTransactionsOpen: word;
   TTS_TotalTransactions: longint;
   TTS_TotalWrites: longint;
   TTS_TotalBackouts: longint;
   TTS_UnfilledBackouts: word;
   TTS_DiskBlocksInUse: word;
   TTS_FATAllocations: longint;
   TTS_FileSizeChanges: longint;
   TTS_FilesTruncated: longint;
   numberOfTransactions: byte;
   connTask: array [0..234] of record
   	connNumber: byte;
   	taskNumber: byte;
	end;
end;

type 
PNWVolumeRestrictions = ^NWVolumeRestrictions;
NWVolumeRestrictions = record
   numberOfEntries: byte;
   resInfo: array [0..11] of record
   objectID: longint;
   restriction: longint;
end;
end;

type 
PNWVOL_RESTRICTIONS = ^NWVOL_RESTRICTIONS;
NWVOL_RESTRICTIONS = record
   numberOfEntries: byte;
   resInfo: array [0..15] of record
   objectID: longint;
   restriction: longint;
end;
end;

type 
PVOL_STATS = ^VOL_STATS;
VOL_STATS = record
   systemElapsedTime: longint;
   volumeNumber: byte;
   logicalDriveNumber: byte;
   sectorsPerBlock: word;
   startingBlock: word;
   totalBlocks: word;
   availableBlocks: word;
   totalDirectorySlots: word;
   availableDirectorySlots: word;
   maxDirectorySlotsUsed: word;
   isHashing: byte;
   isCaching: byte;
   isRemovable: byte;
   isMounted: byte;
   volumeName: array [0..15] of char;
end;

type 
PNWVolExtendedInfo = ^NWVolExtendedInfo;
NWVolExtendedInfo = record
   volType: longint;
   statusFlag: longint;
   sectorSize: longint;
   sectorsPerCluster: longint;
   volSizeInClusters: longint;
   freeClusters: longint;
   subAllocFreeableClusters: longint;
   freeableLimboSectors: longint;
   nonfreeableLimboSectors: longint;
   availSubAllocSectors: longint;
   nonuseableSubAllocSectors: longint;
   subAllocClusters: longint;
   numDataStreams: longint;
   numLimboDataStreams: longint;
   oldestDelFileAgeInTicks: longint;
   numCompressedDataStreams: longint;
   numCompressedLimboDataStreams: longint;
   numNoncompressibleDataStreams: longint;
   precompressedSectors: longint;
   compressedSectors: longint;
   numMigratedDataStreams: longint;
   migratedSectors: longint;
   clustersUsedByFAT: longint;
   clustersUsedByDirs: longint;
   clustersUsedByExtDirs: longint;
   totalDirEntries: longint;
   unusedDirEntries: longint;
   totalExtDirExtants: longint;
   unusedExtDirExtants: longint;
   extAttrsDefined: longint;
   extAttrExtantsUsed: longint;
   DirectoryServicesObjectID: longint;
   volLastModifiedDateAndTime: longint;
end;

type 
PHOLDS_INFO = ^HOLDS_INFO;
HOLDS_INFO = record
   objectID: longint;
   amount: longint;
end;

type 
PHOLDS_STATUS = ^HOLDS_STATUS;
HOLDS_STATUS = record
   holdsCount: word;
   holds: array [0..15] of HOLDS_INFO;
end;

type 
PCACHE_MEM_COUNTERS = ^CACHE_MEM_COUNTERS;
CACHE_MEM_COUNTERS = record
   originalNumOfCacheBuffers: longint;
   currentNumOfCacheBuffers: longint;
   cacheDirtyBlockThreshold: longint;
   waitNodeCount: longint;
   waitNodeAllocFailureCount: longint;
   moveCacheNodeCount: longint;
   moveCacheNodeFromAvailCount: longint;
   accelerateCacheNodeWriteCount: longint;
   removeCacheNodeCount: longint;
   removeCacheNodeFromAvailCount: longint;
end;

type 
PSERVER_AND_VCONSOLE_INFO = ^SERVER_AND_VCONSOLE_INFO;
SERVER_AND_VCONSOLE_INFO = record
   currentServerTime: longint;
   vconsoleVersion: byte;
   vconsoleRevision: byte;
end;

type 
PCACHE_COUNTERS = ^CACHE_COUNTERS;
CACHE_COUNTERS = record
   readExistingBlockCount: longint;
   readExistingWriteWaitCount: longint;
   readExistingPartialReadCount: longint;
   readExistingReadErrorCount: longint;
   writeBlockCount: longint;
   writeEntireBlockCount: longint;
   getDiskCount: longint;
   getDiskNeedToAllocCount: longint;
   getDiskSomeoneBeatMeCount: longint;
   getDiskPartialReadCount: longint;
   getDiskReadErrorCount: longint;
   getAsyncDiskCount: longint;
   getAsyncDiskNeedToAlloc: longint;
   getAsyncDiskSomeoneBeatMe: longint;
   errorDoingAsyncReadCount: longint;
   getDiskNoReadCount: longint;
   getDiskNoReadAllocCount: longint;
   getDiskNoReadSomeoneBeatMeCount: longint;
   diskWriteCount: longint;
   diskWriteAllocCount: longint;
   diskWriteSomeoneBeatMeCount: longint;
   writeErrorCount: longint;
   waitOnSemaphoreCount: longint;
   allocBlockWaitForSomeoneCount: longint;
   allocBlockCount: longint;
   allocBlockWaitCount: longint;
end;

type 
PCACHE_TREND_COUNTERS = ^CACHE_TREND_COUNTERS;
CACHE_TREND_COUNTERS = record
   numCacheChecks: longint;
   numCacheHits: longint;
   numDirtyCacheChecks: longint;
   numDirtyCacheHits: longint;
   cacheUsedWhileChecking: longint;
   waitForDirtyBlocksDecreaseCount: longint;
   allocBlockFromAvailCount: longint;
   allocBlockFromLRUCount: longint;
   allocBlockAlreadyWaiting: longint;
   LRUSittingTime: longint;
end;

type 
PCACHE_INFO = ^CACHE_INFO;
CACHE_INFO = record
   maxByteCount: longint;
   minNumOfCacheBuffers: longint;
   minCacheReportThreshold: longint;
   allocWaitingCount: longint;
   numDirtyBlocks: longint;
   cacheDirtyWaitTime: longint;
   cacheMaxConcurrentWrites: longint;
   maxDirtyTime: longint;
   numOfDirCacheBuffers: longint;
   cacheByteToBlockShiftFactor: longint;
end;

type 
PNWFSE_CACHE_INFO = ^NWFSE_CACHE_INFO;
NWFSE_CACHE_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   cacheCounters: CACHE_COUNTERS;
   cacheMemCounters: CACHE_MEM_COUNTERS;
   cacheTrendCounters: CACHE_TREND_COUNTERS;
   cacheInformation: CACHE_INFO;
end;

type 
PFSE_SERVER_INFO = ^FSE_SERVER_INFO;
FSE_SERVER_INFO = record
   replyCanceledCount: longint;
   writeHeldOffCount: longint;
   writeHeldOffWithDupRequest: longint;
   invalidRequestTypeCount: longint;
   beingAbortedCount: longint;
   alreadyDoingReallocCount: longint;
   deAllocInvalidSlotCount: longint;
   deAllocBeingProcessedCount: longint;
   deAllocForgedPacketCount: longint;
   deAllocStillTransmittingCount: longint;
   startStationErrorCount: longint;
   invalidSlotCount: longint;
   beingProcessedCount: longint;
   forgedPacketCount: longint;
   stillTransmittingCount: longint;
   reExecuteRequestCount: longint;
   invalidSequenceNumCount: longint;
   duplicateIsBeingSentAlreadyCnt: longint;
   sentPositiveAcknowledgeCount: longint;
   sentDuplicateReplyCount: longint;
   noMemForStationCtrlCount: longint;
   noAvailableConnsCount: longint;
   reallocSlotCount: longint;
   reallocSlotCameTooSoonCount: longint;
end;

type 
PFILE_SERVER_COUNTERS = ^FILE_SERVER_COUNTERS;
FILE_SERVER_COUNTERS = record
   tooManyHops: word;
   unknownNetwork: word;
   noSpaceForService: word;
   noReceiveBuffers: word;
   notMyNetwork: word;
   netBIOSProgatedCount: longint;
   totalPacketsServiced: longint;
   totalPacketsRouted: longint;
end;

type 
PNWFSE_FILE_SERVER_INFO = ^NWFSE_FILE_SERVER_INFO;
NWFSE_FILE_SERVER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   NCPStationsInUseCount: longint;
   NCPPeakStationsInUseCount: longint;
   numOfNCPRequests: longint;
   serverUtilization: longint;
   ServerInfo: FSE_SERVER_INFO;
   fileServerCounters: FILE_SERVER_COUNTERS;
end;

type 
PFSE_FILE_SYSTEM_INFO = ^FSE_FILE_SYSTEM_INFO;
FSE_FILE_SYSTEM_INFO = record
   FATMovedCount: longint;
   FATWriteErrorCount: longint;
   someoneElseDidItCount0: longint;
   someoneElseDidItCount1: longint;
   someoneElseDidItCount2: longint;
   iRanOutSomeoneElseDidItCount0: longint;
   iRanOutSomeoneElseDidItCount1: longint;
   iRanOutSomeoneElseDidItCount2: longint;
   turboFATBuildScrededUpCount: longint;
   extraUseCountNodeCount: longint;
   extraExtraUseCountNodeCount: longint;
   errorReadingLastFATCount: longint;
   someoneElseUsingThisFileCount: longint;
end;

type 
PNWFSE_FILE_SYSTEM_INFO = ^NWFSE_FILE_SYSTEM_INFO;
NWFSE_FILE_SYSTEM_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   fileSystemInfo: FSE_FILE_SYSTEM_INFO;
end;

type 
PUSER_INFO = ^USER_INFO;
USER_INFO = record
   connNum: longint;
   useCount: longint;
   connServiceType: byte;
   loginTime: array [0..6] of byte;
   status: longint;
   expirationTime: longint;
   objType: longint;
   transactionFlag: byte;
   logicalLockThreshold: byte;
   recordLockThreshold: byte;
   fileWriteFlags: byte;
   fileWriteState: byte;
   filler: byte;
   fileLockCount: word;
   recordLockCount: word;
   totalBytesRead: array [0..5] of byte;
   totalBytesWritten: array [0..5] of byte;
   totalRequests: longint;
   heldRequests: longint;
   heldBytesRead: array [0..5] of byte;
   heldBytesWritten: array [0..5] of byte;
end;

type 
PNWFSE_USER_INFO = ^NWFSE_USER_INFO;
NWFSE_USER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   userInfo: USER_INFO;
end;

type 
PPACKET_BURST_INFO = ^PACKET_BURST_INFO;
PACKET_BURST_INFO = record
   bigInvalidSlotCount: longint;
   bigForgedPacketCount: longint;
   bigInvalidPacketCount: longint;
   bigStillTransmittingCount: longint;
   stillDoingTheLastRequestCount: longint;
   invalidCtrlRequestCount: longint;
   ctrlInvalidMessageNumCount: longint;
   ctrlBeingTornDownCount: longint;
   bigRepeatTheFileReadCount: longint;
   bigSendExtraCCCount: longint;
   bigReturnAbortMessageCount: longint;
   bigReadInvalidMessageNumCount: longint;
   bigReadDoItOverCount: longint;
   bigReadBeingTornDownCount: longint;
   previousCtrlPacketCount: longint;
   sendHoldOffMessageCount: longint;
   bigReadNoDataAvailableCount: longint;
   bigReadTryingToReadTooMuchCount: longint;
   asyncReadErrorCount: longint;
   bigReadPhysicalReadErrorCount: longint;
   ctrlBadACKFragmentListCount: longint;
   ctrlNoDataReadCount: longint;
   writeDuplicateRequestCount: longint;
   shouldntBeACKingHereCount: longint;
   writeInconsistentPktLengthsCnt: longint;
   firstPacketIsntAWriteCount: longint;
   writeTrashedDuplicateRequestCnt: longint;
   bigWriteInvalidMessageNumCount: longint;
   bigWriteBeingTornDownCount: longint;
   bigWriteBeingAbortedCount: longint;
   zeroACKFragmentCountCount: longint;
   writeCurrentlyTransmittingCount: longint;
   tryingToWriteTooMuchCount: longint;
   writeOutOfMemForCtrlNodesCount: longint;
   writeDidntNeedThisFragmentCount: longint;
   writeTooManyBuffsCheckedOutCnt: longint;
   writeTimeOutCount: longint;
   writeGotAnACKCount: longint;
   writeGotAnACKCount1: longint;
   pollerAbortedTheConnCount: longint;
   maybeHadOutOfOrderWritesCount: longint;
   hadAnOutOfOrderWriteCount: longint;
   movedTheACKBitDownCount: longint;
   bumpedOutOfOrderWriteCount: longint;
   pollerRemovedOldOutOfOrderCount: longint;
   writeDidntNeedButRequestACKCnt: longint;
   writeTrashedPacketCount: longint;
   tooManyACKFragmentsCount: longint;
   savedAnOutOfOrderPacketCount: longint;
   connBeingAbortedCount: longint;
end;

type 
PNWFSE_PACKET_BURST_INFO = ^NWFSE_PACKET_BURST_INFO;
NWFSE_PACKET_BURST_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   packetBurstInfo: PACKET_BURST_INFO;
end;

type 
PIPX_INFO = ^IPX_INFO;
IPX_INFO = record
   IPXSendPacketCount: longint;
   IPXMalformPacketCount: word;
   IPXGetECBRequestCount: longint;
   IPXGetECBFailCount: longint;
   IPXAESEventCount: longint;
   IPXPostponedAESCount: word;
   IPXMaxConfiguredSocketCount: word;
   IPXMaxOpenSocketCount: word;
   IPXOpenSocketFailCount: word;
   IPXListenECBCount: longint;
   IPXECBCancelFailCount: word;
   IPXGetLocalTargetFailCount: word;
end;

type 
PSPX_INFO = ^SPX_INFO;
SPX_INFO = record
   SPXMaxConnsCount: word;
   SPXMaxUsedConns: word;
   SPXEstConnReq: word;
   SPXEstConnFail: word;
   SPXListenConnectReq: word;
   SPXListenConnectFail: word;
   SPXSendCount: longint;
   SPXWindowChokeCount: longint;
   SPXBadSendCount: word;
   SPXSendFailCount: word;
   SPXAbortedConn: word;
   SPXListenPacketCount: longint;
   SPXBadListenCount: word;
   SPXIncomingPacketCount: longint;
   SPXBadInPacketCount: word;
   SPXSuppressedPackCount: word;
   SPXNoSesListenECBCount: word;
   SPXWatchDogDestSesCount: word;
end;

type 
PNWFSE_IPXSPX_INFO = ^NWFSE_IPXSPX_INFO;
NWFSE_IPXSPX_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   IPXInfo: IPX_INFO;
   SPXInfo: SPX_INFO;
end;

type 
PNWFSE_GARBAGE_COLLECTION_INFO = ^NWFSE_GARBAGE_COLLECTION_INFO;
NWFSE_GARBAGE_COLLECTION_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   failedAllocRequestCount: longint;
   numOfAllocs: longint;
   noMoreMemAvailableCount: longint;
   numOfGarbageCollections: longint;
   garbageFoundSomeMem: longint;
   garbageNumOfChecks: longint;
end;

type 
PCPU_INFO = ^CPU_INFO;
CPU_INFO = record
   pageTableOwnerFlag: longint;
   CPUTypeFlag: longint;
   coProcessorFlag: longint;
   busTypeFlag: longint;
   IOEngineFlag: longint;
   FSEngineFlag: longint;
   nonDedicatedFlag: longint;
end;

type 
PNWFSE_CPU_INFO = ^NWFSE_CPU_INFO;
NWFSE_CPU_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numOfCPUs: longint;
   CPUInfo: CPU_INFO;
end;

type 
PVOLUME_SWITCH_INFO = ^VOLUME_SWITCH_INFO;
VOLUME_SWITCH_INFO = record
   readFile: longint;
   writeFile: longint;
   deleteFile: longint;
   renMove: longint;
   openFile: longint;
   createFile: longint;
   createAndOpenFile: longint;
   closeFile: longint;
   scanDeleteFile: longint;
   salvageFile: longint;
   purgeFile: longint;
   migrateFile: longint;
   deMigrateFile: longint;
   createDir: longint;
   deleteDir: longint;
   directoryScans: longint;
   mapPathToDirNum: longint;
   modifyDirEntry: longint;
   getAccessRights: longint;
   getAccessRightsFromIDs: longint;
   mapDirNumToPath: longint;
   getEntryFromPathStrBase: longint;
   getOtherNSEntry: longint;
   getExtDirInfo: longint;
   getParentDirNum: longint;
   addTrusteeR: longint;
   scanTrusteeR: longint;
   delTrusteeR: longint;
   purgeTrust: longint;
   findNextTrustRef: longint;
   scanUserRestNodes: longint;
   addUserRest: longint;
   deleteUserRest: longint;
   rtnDirSpaceRest: longint;
   getActualAvailDskSp: longint;
   cntOwnedFilesAndDirs: longint;
   migFileInfo: longint;
   volMigInfo: longint;
   readMigFileData: longint;
   getVolusageStats: longint;
   getActualVolUsageStats: longint;
   getDirUsageStats: longint;
   NMFileReadsCount: longint;
   NMFileWritesCount: longint;
   mapPathToDirNumOrPhantom: longint;
   stationHasAccessRgtsGntedBelow: longint;
   gtDataStreamLensFromPathStrBase: longint;
   checkAndGetDirectoryEntry: longint;
   getDeletedEntry: longint;
   getOriginalNameSpace: longint;
   getActualFileSize: longint;
   verifyNameSpaceNumber: longint;
   verifyDataStreamNumber: longint;
   checkVolumeNumber: longint;
   commitFile: longint;
   VMGetDirectoryEntry: longint;
   createDMFileEntry: longint;
   renameNameSpaceEntry: longint;
   logFile: longint;
   releaseFile: longint;
   clearFile: longint;
   setVolumeFlag: longint;
   clearVolumeFlag: longint;
   getOriginalInfo: longint;
   createMigratedDir: longint;
   F3OpenCreate: longint;
   F3InitFileSearch: longint;
   F3ContinueFileSearch: longint;
   F3RenameFile: longint;
   F3ScanForTrustees: longint;
   F3ObtainFileInfo: longint;
   F3ModifyInfo: longint;
   F3EraseFile: longint;
   F3SetDirHandle: longint;
   F3AddTrustees: longint;
   F3DeleteTrustees: longint;
   F3AllocDirHandle: longint;
   F3ScanSalvagedFiles: longint;
   F3RecoverSalvagedFiles: longint;
   F3PurgeSalvageableFile: longint;
   F3GetNSSpecificInfo: longint;
   F3ModifyNSSpecificInfo: longint;
   F3SearchSet: longint;
   F3GetDirBase: longint;
   F3QueryNameSpaceInfo: longint;
   F3GetNameSpaceList: longint;
   F3GetHugeInfo: longint;
   F3SetHugeInfo: longint;
   F3GetFullPathString: longint;
   F3GetEffectiveDirectoryRights: longint;
end;

type 
PNWFSE_VOLUME_SWITCH_INFO = ^NWFSE_VOLUME_SWITCH_INFO;
NWFSE_VOLUME_SWITCH_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   totalLFSCounters: longint;
   CurrentLFSCounters: longint;
   LFSCounters: array [0..127] of longint;
end;

type 
PNWFSE_NLM_LOADED_LIST = ^NWFSE_NLM_LOADED_LIST;
NWFSE_NLM_LOADED_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberNLMsLoaded: longint;
   NLMsInList: longint;
   NLMNums: array [0..127] of longint;
end;

type 
PNLM_INFO = ^NLM_INFO;
NLM_INFO = record
   identificationNum: longint;
   flags: longint;
   _type: longint;
   parentID: longint;
   majorVersion: longint;
   minorVersion: longint;
   revision: longint;
   year: longint;
   month: longint;
   day: longint;
   allocAvailableBytes: longint;
   allocFreeCount: longint;
   lastGarbageCollection: longint;
   messageLanguage: longint;
   numOfReferencedPublics: longint;
end;

type 
PNWFSE_NLM_INFO = ^NWFSE_NLM_INFO;
NWFSE_NLM_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   NLMInfo: NLM_INFO;
end;

type 
PDIR_CACHE_INFO = ^DIR_CACHE_INFO;
DIR_CACHE_INFO = record
   minTimeSinceFileDelete: longint;
   absMinTimeSinceFileDelete: longint;
   minNumOfDirCacheBuffers: longint;
   maxNumOfDirCacheBuffers: longint;
   numOfDirCacheBuffers: longint;
   dCMinNonReferencedTime: longint;
   dCWaitTimeBeforeNewBuffer: longint;
   dCMaxConcurrentWrites: longint;
   dCDirtyWaitTime: longint;
   dCDoubleReadFlag: longint;
   mapHashNodeCount: longint;
   spaceRestrictionNodeCount: longint;
   trusteeListNodeCount: longint;
   percentOfVolumeUsedByDirs: longint;
end;

type 
PNWFSE_DIR_CACHE_INFO = ^NWFSE_DIR_CACHE_INFO;
NWFSE_DIR_CACHE_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   dirCacheInfo: DIR_CACHE_INFO;
end;

type 
PNWFSE_OS_VERSION_INFO = ^NWFSE_OS_VERSION_INFO;
NWFSE_OS_VERSION_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   OSMajorVersion: byte;
   OSMinorVersion: byte;
   OSRevisionNum: byte;
   accountingVersion: byte;
   VAPVersion: byte;
   queueingVersion: byte;
   securityRestrictionsLevel: byte;
   bridgingSupport: byte;
   maxNumOfVolumes: longint;
   numOfConnSlots: longint;
   maxLoggedInConns: longint;
   maxNumOfNameSpaces: longint;
   maxNumOfLans: longint;
   maxNumOfMediaTypes: longint;
   maxNumOfProtocols: longint;
   maxMaxSubdirTreeDepth: longint;
   maxNumOfDataStreams: longint;
   maxNumOfSpoolPrinters: longint;
   serialNum: longint;
   applicationNum: word;
end;

type 
PNWFSE_ACTIVE_CONN_LIST = ^NWFSE_ACTIVE_CONN_LIST;
NWFSE_ACTIVE_CONN_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   activeConnBitList: array [0..511] of byte;
end;

type 
PNWFSE_NLMS_RESOURCE_TAG_LIST = ^NWFSE_NLMS_RESOURCE_TAG_LIST;
NWFSE_NLMS_RESOURCE_TAG_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   totalNumOfResourceTags: longint;
   packetResourceTags: longint;
   resourceTagBuf: array [0..511] of byte;
end;

type 
PNWFSE_ACTIVE_LAN_BOARD_LIST = ^NWFSE_ACTIVE_LAN_BOARD_LIST;
NWFSE_ACTIVE_LAN_BOARD_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   MaxNumOfLANs: longint;
   LANLoadedCount: longint;
   boardNums: array [0..63] of longint;
end;

type 
PLAN_CONFIG_INFO = ^LAN_CONFIG_INFO;
LAN_CONFIG_INFO = record
   DriverCFG_MajorVersion: byte;
   DriverCFG_MinorVersion: byte;
   DriverNodeAddress: array [0..5] of byte;
   DriverModeFlags: word;
   DriverBoardNum: word;
   DriverBoardInstance: word;
   DriverMaxSize: longint;
   DriverMaxRecvSize: longint;
   DriverRecvSize: longint;
   Reserved1: array [0..2] of longint;
   DriverCardID: word;
   DriverMediaID: word;
   DriverTransportTime: word;
   DriverReserved: array [0..15] of byte;
   DriverMajorVersion: byte;
   DriverMinorVersion: byte;
   DriverFlags: word;
   DriverSendRetries: word;
   DriverLink: longint;
   DriverSharingFlags: word;
   DriverSlot: word;
   DriverIOPortsAndLengths: array [0..3] of word;
   DriverMemDecode0: longint;
   DriverLength0: word;
   DriverMemDecode1: longint;
   DriverLength1: word;
   DriverInterrupt: array [0..1] of byte;
   DriverDMAUsage: array [0..1] of byte;
   Reserved2: array [0..2] of longint;
   DriverLogicalName: array [0..17] of byte;
   DriverLinearMem: array [0..1] of longint;
   DriverChannelNum: word;
   DriverIOReserved: array [0..5] of byte;
end;

type 
PNWFSE_LAN_CONFIG_INFO = ^NWFSE_LAN_CONFIG_INFO;
NWFSE_LAN_CONFIG_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   LANConfigInfo: LAN_CONFIG_INFO;
end;

type 
PLAN_COMMON_INFO = ^LAN_COMMON_INFO;
LAN_COMMON_INFO = record
   notSupportedMask: longint;
   totalTxPAcketCount: longint;
   totalRxPacketCount: longint;
   noECBAvailableCount: longint;
   packetTxTooBigCount: longint;
   packetTxTooSmallCount: longint;
   packetRxOverflowCount: longint;
   packetRxTooBigCount: longint;
   packetRxTooSmallCount: longint;
   packetTxMiscErrorCount: longint;
   packetRxMiscErrorCount: longint;
   retryTxCount: longint;
   checksumErrorCount: longint;
   hardwareRxMismatchCount: longint;
   reserved: array [0..49] of longint;
end;

type 
PNWFSE_LAN_COMMON_COUNTERS_INFO = ^NWFSE_LAN_COMMON_COUNTERS_INFO;
NWFSE_LAN_COMMON_COUNTERS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   statisticsMajorVersion: byte;
   statisticsMinorVersion: byte;
   numberOfGenericCounters: longint;
   numberOfCounterBlocks: longint;
   customVariableCount: longint;
   NextCounterBlock: longint;
   LANCommonInfo: LAN_COMMON_INFO;
end;

type 
PNWFSE_LAN_CUSTOM_INFO = ^NWFSE_LAN_CUSTOM_INFO;
NWFSE_LAN_CUSTOM_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numCustomVar: longint;
   customInfo: array [0..511] of byte;
end;

type 
PLSL_INFO = ^LSL_INFO;
LSL_INFO = record
   rxBufs: longint;
   rxBufs75PerCent: longint;
   rxBufsCheckedOut: longint;
   rxBufMaxSize: longint;
   maxPhysicalSize: longint;
   lastTimeRxBufAllocated: longint;
   maxNumsOfProtocols: longint;
   maxNumsOfMediaTypes: longint;
   totalTXPackets: longint;
   getECBBfrs: longint;
   getECBFails: longint;
   AESEventCounts: longint;
   postponedEvents: longint;
   ECBCxlFails: longint;
   validBfrsReused: longint;
   enqueuedSendCount: longint;
   totalRXPackets: longint;
   unclaimedPackets: longint;
   StatisticsTableMajorVersion: byte;
   StatisticsTableMinorVersion: byte;
end;

type 
PNWFSE_LSL_INFO = ^NWFSE_LSL_INFO;
NWFSE_LSL_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   LSLInfo: LSL_INFO;
end;

type 
PNWFSE_LSL_LOGICAL_BOARD_STATS = ^NWFSE_LSL_LOGICAL_BOARD_STATS;
NWFSE_LSL_LOGICAL_BOARD_STATS = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved0: word;
   LogTtlTxPackets: longint;
   LogTtlRxPackets: longint;
   LogUnclaimedPackets: longint;
   reserved1: longint;
end;

type 
PMEDIA_INFO_DEF = ^MEDIA_INFO_DEF;
MEDIA_INFO_DEF = record
   _label: array [0..63] of byte;
   identificationtype: longint;
   identificationtimestamp: longint;
end;

type 
PFSE_MM_OBJ_INFO = ^FSE_MM_OBJ_INFO;
FSE_MM_OBJ_INFO = record
   MediaInfo: MEDIA_INFO_DEF;
   mediaType: longint;
   cartridgeType: longint;
   unitSize: longint;
   blockSize: longint;
   capacity: longint;
   preferredUnitSize: longint;
   name: array [0..63] of byte;
   _type: longint;
   status: longint;
   functionMask: longint;
   controlMask: longint;
   parentCount: longint;
   siblingCount: longint;
   childCount: longint;
   specificInfoSize: longint;
   objectUniqueID: longint;
   mediaSlot: longint;
end;

type 
PNWFSE_MEDIA_MGR_OBJ_INFO = ^NWFSE_MEDIA_MGR_OBJ_INFO;
NWFSE_MEDIA_MGR_OBJ_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   fseMMObjInfo: FSE_MM_OBJ_INFO;
end;

type 
PNWFSE_MEDIA_MGR_OBJ_LIST = ^NWFSE_MEDIA_MGR_OBJ_LIST;
NWFSE_MEDIA_MGR_OBJ_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   nextStartObjNum: longint;
   objCount: longint;
   objs: array [0..127] of longint;
end;

type 
PVOLUME_SEGMENT = ^VOLUME_SEGMENT;
VOLUME_SEGMENT = record
   volumeSegmentDeviceNum: longint;
   volumeSegmentOffset: longint;
   volumeSegmentSize: longint;
end;

type 
PNWFSE_VOLUME_SEGMENT_LIST = ^NWFSE_VOLUME_SEGMENT_LIST;
NWFSE_VOLUME_SEGMENT_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numOfVolumeSegments: longint;
   volumeSegment: array [0..41] of VOLUME_SEGMENT;
end;

type 
PVOLUME_INFO_BY_LEVEL_DEF = ^VOLUME_INFO_BY_LEVEL_DEF;
VOLUME_INFO_BY_LEVEL_DEF = record
   volumeType: longint;
   statusFlagBits: longint;
   sectorSize: longint;
   sectorsPerCluster: longint;
   volumeSizeInClusters: longint;
   freedClusters: longint;
   subAllocFreeableClusters: longint;
   freeableLimboSectors: longint;
   nonFreeableLimboSectors: longint;
   nonFreeableAvailSubAllocSectors: longint;
   notUsableSubAllocSectors: longint;
   subAllocClusters: longint;
   dataStreamsCount: longint;
   limboDataStreamsCount: longint;
   oldestDeletedFileAgeInTicks: longint;
   compressedDataStreamsCount: longint;
   compressedLimboDataStreamsCount: longint;
   unCompressableDataStreamsCount: longint;
   preCompressedSectors: longint;
   compressedSectors: longint;
   migratedFiles: longint;
   migratedSectors: longint;
   clustersUsedByFAT: longint;
   clustersUsedByDirectories: longint;
   clustersUsedByExtendedDirs: longint;
   totalDirectoryEntries: longint;
   unUsedDirectoryEntries: longint;
   totalExtendedDirectoryExtants: longint;
   unUsedExtendedDirectoryExtants: longint;
   extendedAttributesDefined: longint;
   extendedAttributeExtantsUsed: longint;
   directoryServicesObjectID: longint;
   volumeLastModifiedDateAndTime: longint;
end;

type 
PVOLUME_INFO_BY_LEVEL_DEF2 = ^VOLUME_INFO_BY_LEVEL_DEF2;
VOLUME_INFO_BY_LEVEL_DEF2 = record
   volumeActiveCount: longint;
   volumeUseCount: longint;
   mACRootIDs: longint;
   volumeLastModifiedDateAndTime: longint;
   volumeReferenceCount: longint;
   compressionLowerLimit: longint;
   outstandingIOs: longint;
   outstandingCompressionIOs: longint;
   compressionIOsLimit: longint;
end;


type
PVOLUME_INFO_BY_LEVEL = ^VOLUME_INFO_BY_LEVEL;
VOLUME_INFO_BY_LEVEL = record
case integer of
   0: (volInfoDef: VOLUME_INFO_BY_LEVEL_DEF);
   1: (volInfoDef2: VOLUME_INFO_BY_LEVEL_DEF2);
end;

type 
PNWFSE_VOLUME_INFO_BY_LEVEL = ^NWFSE_VOLUME_INFO_BY_LEVEL;
NWFSE_VOLUME_INFO_BY_LEVEL = record
   serverAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   infoLevel: longint;
   volumeInfo: VOLUME_INFO_BY_LEVEL;
end;

type 
PSTACK_INFO = ^STACK_INFO;
STACK_INFO = record
   StackNum: longint;
   StackShortName: array [0..15] of byte;
end;

type 
PNWFSE_ACTIVE_STACKS = ^NWFSE_ACTIVE_STACKS;
NWFSE_ACTIVE_STACKS = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   maxNumOfStacks: longint;
   stackCount: longint;
   nextStartNum: longint;
   stackInfo: array [0..24] of STACK_INFO;
end;

type 
PNWFSE_PROTOCOL_STK_CONFIG_INFO = ^NWFSE_PROTOCOL_STK_CONFIG_INFO;
NWFSE_PROTOCOL_STK_CONFIG_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   configMajorVersionNum: byte;
   configMinorVersionNum: byte;
   stackMajorVersionNum: byte;
   stackMinorVersionNum: byte;
   stackShortName: array [0..15] of byte;
end;

type 
PNWFSE_PROTOCOL_STK_STATS_INFO = ^NWFSE_PROTOCOL_STK_STATS_INFO;
NWFSE_PROTOCOL_STK_STATS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   statMajorVersionNum: byte;
   statMinorVersionNum: byte;
   commonCounters: word;
   validCountersMask: longint;
   totalTxPackets: longint;
   totalRxPackets: longint;
   ignoredRxPackets: longint;
   numCustomCounters: word;
end;

type 
PNWFSE_PROTOCOL_CUSTOM_INFO = ^NWFSE_PROTOCOL_CUSTOM_INFO;
NWFSE_PROTOCOL_CUSTOM_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved0: word;
   customCount: longint;
   customStruct: array [0..511] of byte;
end;

type 
PNWFSE_PROTOCOL_ID_NUMS = ^NWFSE_PROTOCOL_ID_NUMS;
NWFSE_PROTOCOL_ID_NUMS = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   stackIDCount: longint;
   stackIDs: array [0..127] of longint;
end;

type 
PNWFSE_MEDIA_NAME_LIST = ^NWFSE_MEDIA_NAME_LIST;
NWFSE_MEDIA_NAME_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
end;

type 
PNWFSE_LOADED_MEDIA_NUM_LIST = ^NWFSE_LOADED_MEDIA_NUM_LIST;
NWFSE_LOADED_MEDIA_NUM_LIST = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   maxMediaTypes: longint;
   mediaListCount: longint;
   mediaList: array [0..31] of longint;
end;

type 
PNWFSE_GENERAL_ROUTER_SAP_INFO = ^NWFSE_GENERAL_ROUTER_SAP_INFO;
NWFSE_GENERAL_ROUTER_SAP_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   internalRIPSocket: longint;
   internalRouterDownFlag: longint;
   trackOnFlag: longint;
   externalRouterActiveFlag: longint;
   internalSAPSocketNumber: longint;
   replyToNearestServerFlag: longint;
end;

type 
PNWFSE_NETWORK_ROUTER_INFO = ^NWFSE_NETWORK_ROUTER_INFO;
NWFSE_NETWORK_ROUTER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   NetIDNumber: longint;
   HopsToNet: word;
   NetStatus: word;
   TimeToNet: word;
end;

type 
PROUTERS_INFO = ^ROUTERS_INFO;
ROUTERS_INFO = record
   nodeAddress: array [0..5] of byte;
   connectedLAN: longint;
   routeHops: word;
   routeTime: word;
end;

type 
PNWFSE_NETWORK_ROUTERS_INFO = ^NWFSE_NETWORK_ROUTERS_INFO;
NWFSE_NETWORK_ROUTERS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   NumberOfEntries: longint;
   routersInfo: array [0..35] of ROUTERS_INFO;
end;

type 
PKNOWN_NET_INFO = ^KNOWN_NET_INFO;
KNOWN_NET_INFO = record
   netIDNumber: longint;
   hopsToNet: word;
   netStatus: word;
   timeToNet: word;
end;

type 
PNWFSE_KNOWN_NETWORKS_INFO = ^NWFSE_KNOWN_NETWORKS_INFO;
NWFSE_KNOWN_NETWORKS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfEntries: longint;
   knownNetInfo: array [0..50] of KNOWN_NET_INFO;
end;

type 
PNWFSE_SERVER_INFO = ^NWFSE_SERVER_INFO;
NWFSE_SERVER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   serverAddress: array [0..11] of byte;
   hopsToServer: word;
end;

type 
PSERVERS_SRC_INFO = ^SERVERS_SRC_INFO;
SERVERS_SRC_INFO = record
   serverNode: array [0..5] of byte;
   connectedLAN: longint;
   sourceHops: word;
end;

type 
PNWFSE_SERVER_SRC_INFO = ^NWFSE_SERVER_SRC_INFO;
NWFSE_SERVER_SRC_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfEntries: longint;
   serversSrcInfo: array [0..41] of SERVERS_SRC_INFO;
end;

type 
PNWFSE_KNOWN_SERVER_INFO = ^NWFSE_KNOWN_SERVER_INFO;
NWFSE_KNOWN_SERVER_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfEntries: longint;
   data: array [0..511] of byte;
end;

type 
PNWFSE_SERVER_SET_CMDS_INFO = ^NWFSE_SERVER_SET_CMDS_INFO;
NWFSE_SERVER_SET_CMDS_INFO = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfSetCommands: longint;
   nextSequenceNumber: longint;
   setCmdType: longint;
   setCmdCategory: longint;
   setCmdFlags: longint;
   setNameAndValueInfo: array [0..499] of byte;
end;

type
PNWFSE_SERVER_SET_CATEGORIES = ^NWFSE_SERVER_SET_CATEGORIES;
NWFSE_SERVER_SET_CATEGORIES = record
   serverTimeAndVConsoleInfo: SERVER_AND_VCONSOLE_INFO;
   reserved: word;
   numberOfSetCategories: longint;
   nextSequenceNumber: longint;
   categoryName: array [0..511] of byte;
end;

type
PSEARCH_DIR_INFO = ^SEARCH_DIR_INFO;
SEARCH_DIR_INFO = record
  SequenceNumber: word;
  Reserved1: word;
  DirectoryName: array [0..14] of char;
  DirectoryAttributes: byte;
  DirectoryAccessRights: byte;
  CreateDate: word;
  CreateTime: word;
  owningObjectID: longint;
  reserved2: word;
  DirectoryStamp: word;
end;

type
PSEARCH_FILE_INFO = ^SEARCH_FILE_INFO;
SEARCH_FILE_INFO = record
  SequenceNumber: word;
  Reserved1: word;
  FileName: array [0..14] of char;
  FileAttributes: byte;
  FileMode: byte;
  FileLenght: longint;
  CreateDate: word;
  AccesDate: word;
  UpdateDate: word;
  UpdateTime: word;
end;

type
PSEARCH_INFO = ^SEARCH_INFO;
SEARCH_INFO = record
case integer of
   0: (fich: SEARCH_FILE_INFO);
   1: (dir: SEARCH_DIR_INFO);
end;

implementation

end.
