unit TNWPpte;

interface

uses TNWObj, Classes;

type TNWPropriete = class
    private
        { Private-dclarations }
        FProprietaire: TNWObject;
        FPpteNom: string;
        FPpteFlags: Byte; { contient DYNAMIC STATIC SET ITEMS }
        FPpteSecurite: Byte;
        FPpteADesValeurs: Boolean;
        function GetPpteValeur(Num: Word): String;
        procedure SetPpteValeur(Num: Word; Chaine: String);
    protected
        { Protected-dclarations }
    public
        { Public-dclarations }
        constructor Create(Parent: TNWObject; PpteNom: String; PpteFlags, PpteSecurite: Byte; ADesValeurs: Byte);
        function ChercheObjectDansSet(Obj: TNWObject): Word;
        function EnleveObjectDansSet(Obj: TNWObject): Word;
        function AjouteObjectDansSet(Obj: TNWObject): Word;
        function Delete: Word;
        procedure AjouteValeur(Valeur: string);
        procedure EnleveValeur(Index: Integer);
        property Proprietaire: TNWObject read FProprietaire;
        property PpteNom: string read FPpteNom;
        property PpteFlags: Byte read FPpteFlags;
        property PpteSecurite: Byte read FPpteSecurite;
        property PpteADesValeurs: Boolean read FPpteADesValeurs;
        property PpteValeurs[Num: Word]: String read GetPpteValeur write SetPpteValeur;
    end;

implementation

uses SysUtils, NLMUti;

{********************************************* P U B L I C ************************************************************}
constructor TNWPropriete.Create(Parent: TNWObject; PpteNom: String; PpteFlags, PpteSecurite: Byte; ADesValeurs: Byte);
begin
    FProprietaire := Parent;
    FPpteNom := PpteNom;
    FPpteFlags := PpteFlags;
    FPpteSecurite := PpteSecurite;
    FPpteADesValeurs := (ADesValeurs = $FF);
end;


function TNWPropriete.ChercheObjectDansSet(Obj: TNWObject): Word;
var Ret: Word;
    PObjNom, PPpteNom, PObjMembreNom: PChar;
begin
    GetMem(PObjNom, 48);
    StrPCopy(PObjNom, Proprietaire.ObjNom);
    GetMem(PPpteNom, 15);
    StrPCopy(PPpteNom, FPpteNom);
    GetMem(PObjMembreNom, 48);
    StrPCopy(PObjMembreNom, Obj.ObjNom);
    Result := IsObjectInSet(Proprietaire.Proprietaire.NWConn.Handle, PObjNom,
                                Proprietaire.ObjType, PPpteNom, PObjMembreNom,
                                Obj.ObjType);
    FreeMem(PObjMembreNom, 48);
    FreeMem(PPpteNom, 15);
    FreeMem(PObjNom, 48);
end;


function TNWPropriete.EnleveObjectDansSet(Obj: TNWObject): Word;
var Ret: Word;
    PObjNom, PPpteNom, PObjMembreNom: PChar;
begin
    GetMem(PObjNom, 48);
    StrPCopy(PObjNom, Proprietaire.ObjNom);
    GetMem(PPpteNom, 15);
    StrPCopy(PPpteNom, FPpteNom);
    GetMem(PObjMembreNom, 48);
    StrPCopy(PObjMembreNom, Obj.ObjNom);
    Result := DeleteObjectFromSet(Proprietaire.Proprietaire.NWConn.Handle, PObjNom, Proprietaire.ObjType, PPpteNom,
                        PObjMembreNom, Obj.ObjType);
    FreeMem(PObjMembreNom, 48);
    FreeMem(PPpteNom, 15);
    FreeMem(PObjNom, 48);
end;


function TNWPropriete.AjouteObjectDansSet(Obj: TNWObject): Word;
var Ret: Word;
    PObjNom, PPpteNom, PObjMembreNom: PChar;
begin
    GetMem(PObjNom, 48);
    StrPCopy(PObjNom, Proprietaire.ObjNom);
    GetMem(PPpteNom, 15);
    StrPCopy(PPpteNom, FPpteNom);
    GetMem(PObjMembreNom, 48);
    StrPCopy(PObjMembreNom, Obj.ObjNom);
    Result := AddObjectToSet(Proprietaire.Proprietaire.NWConn.Handle, PObjNom, Proprietaire.ObjType, PPpteNom, PObjMembreNom,
                                Obj.ObjType);
    FreeMem(PObjMembreNom, 48);
    FreeMem(PPpteNom, 15);
    FreeMem(PObjNom, 48);
end;


function TNWPropriete.Delete: Word;
var PObjNom, PPpteNom: PChar;
    Buffer: string[128];
begin
    GetMem(PObjNom, 48);
    StrPCopy(PObjNom, Proprietaire.ObjNom);
    GetMem(PPpteNom, 15);
    StrPCopy(PPpteNom, FPpteNom);
    Result := DeleteProperty(PRoprietaire.Proprietaire.NWConn.Handle, PObjNom, Proprietaire.ObjType, PPpteNom);
    FreeMem(PPpteNom, 15);
    FreeMem(PObjNom, 48);
end;


procedure TNWPropriete.AjouteValeur(Valeur: string);
var Compteur: Integer;
begin
    Compteur := 1;
    while (GetPpteValeur(Compteur) <> '') do Inc(Compteur);
    SetPpteValeur(Compteur, Valeur);
end;


procedure TNWPropriete.EnleveValeur(Index: Integer);
var Compteur: Integer;
begin
    Compteur := Index;
    while (GetPpteValeur(Compteur) <> '') do
        SetPpteValeur(Compteur, GetPpteValeur(Compteur + 1));
end;


{********************************************** P R I V A T E ********************************************************}
function TNWPropriete.GetPpteValeur(Num: Word): String;
var Ret: Word;
    PObjNom, PPpteNom: PChar;
    Flags, Encore: Byte;
    Buffer: string[128];
begin
    GetMem(PObjNom, 48);
    StrPCopy(PObjNom, Proprietaire.ObjNom);
    GetMem(PPpteNom, 15);
    StrPCopy(PPpteNom, FPpteNom);
    Ret := ReadPropertyValue(Proprietaire.Proprietaire.NWConn.Handle, PObjNom, Proprietaire.ObjType, PPpteNom,
                                Num, @Buffer[1], @Encore, @Flags);
    if (Ret = 0) then Buffer[0] := #128
    else Buffer[0] := #0;
    Result := Buffer;
    FreeMem(PPpteNom, 15);
    FreeMem(PObjNom, 48);
end;


procedure TNWPropriete.SetPpteValeur(Num: Word; Chaine: string);
var Ret: Word;
    PObjNom, PPpteNom, PChaine: PChar;
begin
    GetMem(PObjNom, 48);
    StrPCopy(PObjNom, Proprietaire.ObjNom);
    GetMem(PPpteNom, 15);
    StrPCopy(PPpteNom, FPpteNom);
    GetMem(PChaine, 256);
    for Ret := 0 to 127 do PChaine[Ret] := #0;
    StrPCopy(PChaine, Chaine);
    Ret := WritePropertyValue(Proprietaire.Proprietaire.NWConn.Handle, PObjNom, Proprietaire.ObjType, PPpteNom,
                                Num, @PChaine[0], 0);
    FreeMem(PChaine, 256);
    FreeMem(PPpteNom, 15);
    FreeMem(PObjNom, 48);
end;

end.
