unit TNWTrust;

interface

uses Classes, TNWObj;

type
    TDroit = class
        Droit: Byte;
    end;

    TNWTrustee = class (TNWObject)
    private
        { Private-dclarations }
    protected
        { Protected-dclarations }
        procedure FreeObjListe(Liste: TStrings);
    public
        { Public-dclarations }
        procedure ChercheTrusteePaths(TrusteesPaths: TStrings);
        procedure AssignTrusteePath(Path: String; Droit: Byte);
    end;

implementation

uses SysUtils,
        NLMUti;

procedure TNWTrustee.ChercheTrusteePaths(TrusteesPaths: TStrings);
var NumSequence: Word;
    Droit: Byte;
    Chemin: PChar;
    NouveauDroit: TDroit;
    Compteur: Integer;
    Ret: Integer;
begin
    FreeObjListe(TrusteesPaths);
    TrusteesPaths.Clear;
    GetMem(Chemin, 320);
    NumSequence := $ffff;
    for Compteur := 0 to 63 do
    begin
        NumSequence := $ffff;
        repeat
            Ret := ScanObjectTrusteePaths(Proprietaire.NWConn.Handle, ObjID, Compteur, @NumSequence, @Droit, Chemin);
            if ((Chemin[0] <> #0) and (Ret = 0)) then
            begin
                NouveauDroit := TDroit.Create;
                NouveauDroit.Droit := Droit;
                TrusteesPaths.AddObject(StrPas(Chemin), NouveauDroit);
            end;
        until ((Ret <> 0) or (Chemin[0] = #0));
        if ((Ret <> 0) and (NumSequence = 0)) then Compteur := 63;
    end;
    FreeMem(Chemin, 320);
end;


procedure TNWTrustee.AssignTrusteePath(Path: String; Droit: Byte);
var PPath: PChar;
begin
    GetMem(PPath, 256);
    StrPCopy(PPath, Path);
    DeleteTrusteeFromDirectory(Proprietaire.NWConn.Handle, 0, PPath, ObjId);
    if (Droit <> 0) then AddTrusteeToDirectory(Proprietaire.NWConn.Handle, 0, PPath, ObjId, Droit);
    FreeMem(PPath, 256);
end;

{********************************** P U B L I C **********************************************}
procedure TNWTrustee.FreeObjListe(Liste: TStrings);
var Compteur: Integer;
begin
    for Compteur:=0 to Liste.Count-1 do Liste.Objects[Compteur].Free;
end;


end.
