unit TNWUti;

interface

uses Classes,
        TNWTrust;

type
    TNWUtilisateur = class(TNWTrustee)
    private
        { Private-dclarations }
        FBalance: String[128];
        LoginControl: String[128];
        procedure EcrireLoginControl;
    protected
        { Protected-dclarations }
    public
        { Public-dclarations }
        procedure LectureBalance;
        procedure LectureLoginControl;
        function ChercheNom: String;
        procedure AssignNom(Nom: String);
        function ChercheSurnom: String;
        procedure AssignSurNom(SurNom: String);
        function ChercheNomComplet: String;
        procedure AssignNomComplet(NomComplet: String);
        function ChercheInitiale: String;
        procedure AssignInitiale(Initiale: String);
        procedure ChercheTitres(Titres: TStrings);
        procedure AssignTitres(Titres: TStrings);
        procedure ChercheTelephones(Telephones: TStrings);
        procedure AssignTelephones(Telephones: TStrings);
        procedure ChercheGroupes(Groupes: TStrings);
        procedure AssignGroupes(Groupes: TStrings);
        procedure ChercheEquivalences(Equivalences: TStrings);
        procedure AssignEquivalences(Equivalences: TStrings);
        function ChercheRue: String;
        procedure AssignRue(Rue: String);
        function ChercheCentre: String;
        procedure AssignCentre(Centre: String);
        function ChercheVille: String;
        procedure AssignVille(Ville: String);
        function ChercheEtat: String;
        procedure AssignEtat(Etat: String);
        function ChercheCP: String;
        procedure AssignCP(CP: String);
        function ChercheBalance: String;
        procedure AssignBalance(Balance: String);
        function ChercheCredit: Boolean;
        procedure MetCredit;
        function ChercheLowBalance: String;
        procedure AssignLowBalance(LowBalance: String);
        function ChercheCompteDesactif: Boolean;
        procedure AssignCompteDesactif(CompteActif: Boolean);
        function ChercheADateExpiration: Boolean;
        function ChercheDateExpiration: String;
        procedure EnleveDateExpiration;
        procedure AssignDateExpiration(Date: String);
        function ChercheANbConnectionLimite: Boolean;
        procedure EnleveANbConnectionLimite;
        function ChercheNbConnectionLimite: String;
        procedure AssignNbConnectionLimite(NbConnectionLimite: String);
        function ChercheDateLastLogin: String;
        procedure AssignDateLastLogin(Date: String);
        function ChercheHeureLastLogin: String;
        procedure AssignHeureLastLogin(Heure: String);
        function DonneRestrictionsTemporelle: TMemoryStream;
        procedure AssignRestrictionsTemporelle(Tab: TMemoryStream);
        function CherchePeutChangerPassWord: Boolean;
        procedure AssignPeutChangerPassWord(Ok: Boolean);
        function CherchePasswordObligatoire: Boolean;
        procedure AssignTailleMiniPassword(Mini: String);
        function ChercheTailleMiniPassword: String;
        function ChercheChgtPasswordObligatoire: Boolean;
        function ChercheNbJoursEntreChgt: String;
        procedure AssignNbJoursEntreChgt(NbJours: String);
        function ChercheDateExpirationPassword: String;
        procedure AssignDateExpirationPassword(Date: String);
        function ChercheNbLoginPermis: String;
        procedure AssignNbLoginPermis(NbLoginPermis: String);
        function ChercheNbLoginRestant: String;
        procedure AssignNbLoginRestant(NbLoginRestant: String);
        function ChercheDelaiGrace: Boolean;
        procedure EnleveDelaiGrace;
        function CherchePasswordRequis: Boolean;
        procedure AssignPasswordRequis(Requis: Boolean);
    end;

implementation

uses SysUtils;

procedure TNWUtilisateur.LectureBalance;
var Compteur: Integer;
begin
    FBalance := ChercheInfoDans('ACCOUNT_BALANCE');
    if (FBalance[0] = #0) then
    for Compteur := 1 to 128 do FBalance[Compteur] := #0;
end;

procedure TNWUtilisateur.LectureLoginControl;
var Compteur: Integer;
begin
    LoginControl := ChercheInfoDans('LOGIN_CONTROL');
    if (LoginControl[0] = #0) then
    for Compteur := 1 to 128 do LoginControl[Compteur] := #0;
end;

function TNWUtilisateur.ChercheNom: String;
begin
    Result := ChercheInfoDans('SURNAME');
end;

procedure TNWUtilisateur.AssignNom(Nom: String);
begin
    AssignInfoDans('SURNAME', Nom);
end;

function TNWUtilisateur.ChercheSurnom: String;
begin
    Result := ChercheInfoDans('GIVEN_NAME');
end;

procedure TNWUtilisateur.AssignSurNom(SurNom: String);
begin
    AssignInfoDans('GIVEN_NAME', SurNom);
end;

function TNWUtilisateur.ChercheNomComplet: String;
begin
    Result := ChercheInfoDans('IDENTIFICATION');
end;

procedure TNWUtilisateur.AssignNomComplet(NomComplet: String);
begin
    AssignInfoDans('IDENTIFICATION', NomComplet);
end;

function TNWUtilisateur.ChercheInitiale: String;
begin
    Result := ChercheInfoDans('INITIALS');
end;

procedure TNWUtilisateur.AssignInitiale(Initiale: String);
begin
    AssignInfoDans('INITIALS', Initiale);
end;

procedure TNWUtilisateur.ChercheTitres(Titres: TStrings);
begin
    ChercheInfosDans(Titres, 'TITLE');
end;

procedure TNWUtilisateur.AssignTitres(Titres: TStrings);
begin
    AssignInfosDans('TITLE', Titres);
end;

procedure TNWUtilisateur.ChercheTelephones(Telephones: TStrings);
begin
    ChercheInfosDans(Telephones, 'PHONE_NUMBER');
end;

procedure TNWUtilisateur.AssignTelephones(Telephones: TStrings);
begin
    AssignInfosDans('PHONE_NUMBER', Telephones);
end;

procedure TNWUtilisateur.ChercheGroupes(Groupes: TStrings);
begin
    ChercheObjectsDansSet(Groupes, 'GROUPS_I''M_IN');
end;

procedure TNWUtilisateur.AssignGroupes(Groupes: TStrings);
begin
    AssignObjectsDansSet('GROUPS_I''M_IN', Groupes);
end;

procedure TNWUtilisateur.ChercheEquivalences(Equivalences: TStrings);
begin
    ChercheObjectsDansSet(Equivalences, 'SECURITY_EQUALS');
end;

procedure TNWUtilisateur.AssignEquivalences(Equivalences: TStrings);
begin
    AssignObjectsDansSet('SECURITY_EQUALS', Equivalences);
end;

function TNWUtilisateur.ChercheRue: String;
begin
    Result := ChercheInfoDans('SA');
end;

procedure TNWUtilisateur.AssignRue(Rue: String);
begin
    AssignInfoDans('SA', Rue);
end;

function TNWUtilisateur.ChercheCentre: String;
begin
    Result := ChercheInfoDans('POST_OFFICE_BOX');
end;

procedure TNWUtilisateur.AssignCentre(Centre: String);
begin
    AssignInfoDans('POST_OFFICE_BOX', Centre);
end;

function TNWUtilisateur.ChercheVille: String;
begin
    Result := ChercheInfoDans('DELIVERY_OFFICE');
end;

procedure TNWUtilisateur.AssignVille(Ville: String);
begin
    AssignInfoDans('DELIVERY_OFFICE', Ville);
end;

function TNWUtilisateur.ChercheEtat: String;
begin
    Result := ChercheInfoDans('S');
end;

procedure TNWUtilisateur.AssignEtat(Etat: String);
begin
    AssignInfoDans('S', Etat);
end;

function TNWUtilisateur.ChercheCP: String;
begin
    Result := ChercheInfoDans('POSTAL_CODE');
end;

procedure TNWUtilisateur.AssignCP(CP: String);
begin
    AssignInfoDans('POSTAL_CODE', CP);
end;


{****************************************** B A L A N C E  *******************************************}
function TNWUtilisateur.ChercheBalance: String;
var Num: LongInt;
    Compteur: Integer;
begin
    Num := 0;
    for Compteur := 1 to 4 do Num := (Num shl 8) + Byte(FBalance[Compteur]);
    Result := IntToStr(Num);
end;

procedure TNWUtilisateur.AssignBalance(Balance: String);
var Compteur: Integer;
    NBalance: LongInt;
begin
    NBalance := StrToInt(Balance);
    for Compteur := 4 downto 1 do
    begin
        FBalance[Compteur] := Chr(NBalance and $FF);
        NBalance := NBalance shr 8;
    end;
    FBalance[0] := #128;
    AssignInfoDans('ACCOUNT_BALANCE', FBalance);
end;

function TNWUtilisateur.ChercheCredit: Boolean;
var Num: LongInt;
    Compteur: Integer;
begin
    Num := 0;
    for Compteur := 5 to 8 do Num := (Num shl 8) + Byte(FBalance[Compteur]);
    Result := (Num = $80000000);
end;

procedure TNWUtilisateur.MetCredit;
begin
    FBalance[5] := #$80;
    FBalance[6] := #0;
    FBalance[7] := #0;
    FBalance[8] := #0;
    AssignInfoDans('ACCOUNT_BALANCE', FBalance);
end;

function TNWUtilisateur.ChercheLowBalance: String;
var Num: LongInt;
    Compteur: Integer;
begin
    Num := 0;
    for Compteur := 5 to 8 do Num := (Num shl 8) + Byte(FBalance[Compteur]);
    Result := IntToStr(Num);
end;

procedure TNWUtilisateur.AssignLowBalance(LowBalance: String);
var Compteur: Integer;
    NLowBalance: LongInt;
begin
    NLowBalance := StrToInt(LowBalance);
    for Compteur := 8 downto 5 do
    begin
        FBalance[Compteur] := Chr(NLowBalance and $FF);
        NLowBalance := NLowBalance shr 8;
    end;
    FBalance[0] := #128;
    AssignInfoDans('ACCOUNT_BALANCE', FBalance);
end;


{******************************** L O G I N _ C O N T R O L *************************************}
procedure TNWUtilisateur.EcrireLoginControl;
begin
    { NETWARE inc de 1 le jour et l'heure du LAST LOGIN (=ajoute 25 heures) ???????????}
    AssignInfoDans('LOGIN_CONTROL', LoginControl);
end;

function TNWUtilisateur.ChercheCompteDesactif: Boolean;
begin
    Result := (LoginControl[4] = #1);
end;

procedure TNWUtilisateur.AssignCompteDesactif(CompteActif: Boolean);
begin
    if CompteActif then LoginControl[4] := #0
    else LoginControl[4] := #1;
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheADateExpiration: Boolean;
var Compteur: Integer;
begin
    Result := False;
    for Compteur := 1 to 3 do if (LoginControl[Compteur] <> #0) then Result := True;
end;

procedure TNWUtilisateur.EnleveDateExpiration;
begin
    LoginControl[1] := #0;
    LoginControl[2] := #0;
    LoginControl[3] := #0;
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheDateExpiration: String;
begin
    FmtStr(Result, '%.2d%.2d%.4d', [Byte(LoginControl[3]), Byte(LoginControl[2]), 1900+(Byte(LoginControl[1]))]);
end;

procedure TNWUtilisateur.AssignDateExpiration(Date: String);
begin
    LoginControl[3] := Chr(StrToInt(Copy(Date, 1, 2)));
    LoginControl[2] := Chr(StrToInt(Copy(Date, 3, 2)));
    LoginControl[1] := Chr(StrToInt(Copy(Date, 5, 4)) - 1900);
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheANbConnectionLimite: Boolean;
begin
    Result := False;
    if (LoginControl[13] <> #0) then Result := True;
    if (LoginControl[14] <> #0) then Result := True;
end;

procedure TNWUtilisateur.EnleveANbConnectionLimite;
begin
    LoginControl[13] := #0;
    LoginControl[14] := #0;
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheNbConnectionLimite: String;
begin
    Result := IntToStr((Byte(LoginControl[13]) shl 8) + Byte(LoginControl[14]));
end;

procedure TNWUtilisateur.AssignNbConnectionLimite(NbConnectionLimite: String);
var Num: Integer;
begin
    Num := StrToInt(NbConnectionLimite);
    LoginControl[13] := Chr(Num shr 8);
    LoginControl[14] := Chr(Num and $FF);
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheDateLastLogin: String;
begin
    FmtStr(Result, '%.2d%.2d%.2d', [Byte(LoginControl[59]), Byte(LoginControl[58]), 1900+(Byte(LoginControl[57]))]);
end;

procedure TNWUtilisateur.AssignDateLastLogin(Date: String);
begin
    LoginControl[59] := Chr(StrToInt(Copy(Date, 1, 2)));
    LoginControl[58] := Chr(StrToInt(Copy(Date, 3, 2)));
    LoginControl[57] := Chr(StrToInt(Copy(Date, 5, 4)) - 1900);
    EcrireLoginControl;
end;


function TNWUtilisateur.ChercheHeureLastLogin: String;
begin
    FmtStr(Result, '%.2d%.2d%.2d', [Byte(LoginControl[60]), Byte(LoginControl[61]), Byte(LoginControl[62])]);
end;

procedure TNWUtilisateur.AssignHeureLastLogin(Heure: String);
begin
    LoginControl[60] := Chr(StrToInt(Copy(Heure, 1, 2)));
    LoginControl[61] := Chr(StrToInt(Copy(Heure, 3, 2)));
    LoginControl[62] := Chr(StrToInt(Copy(Heure, 5, 4)));
    EcrireLoginControl;
end;


function TNWUtilisateur.DonneRestrictionsTemporelle: TMemoryStream;
var Compteur1, Compteur2: Integer;
    Memoire: TMemoryStream;
    Buffer: Byte;
    Masque: Byte;
    C0, C1: Byte;
begin
    C0 := 0;
    C1 := 1;
    Memoire := TMemoryStream.Create;
    Buffer := Byte(LoginControl[15]);
    Masque := 4;
    for Compteur2 := 3 to 8 do
    begin
        if ((Buffer and Masque) = 0) then Memoire.Write(C1, 1)
        else Memoire.Write(C0, 1);
        Masque := Masque shl 1;
    end;
    for Compteur1 := 16 to 56 do
    begin
        Masque := 1;
        Buffer := Byte(LoginControl[Compteur1]);
        for Compteur2 := 1 to 8 do
        begin
            if ((Buffer and Masque) = 0) then Memoire.Write(C1, 1)
            else Memoire.Write(C0, 1);
            Masque := Masque shl 1;
        end;
    end;
    Buffer := Byte(LoginControl[15]);
    if ((Buffer and 1) = 0) then Memoire.Write(C1, 1)
    else Memoire.Write(C0, 1);
    if ((Buffer and 2) = 0) then Memoire.Write(C1, 1)
    else Memoire.Write(C0, 1);

    Memoire.Seek(0, 0);
    Result := Memoire;
end;

procedure TNWUtilisateur.AssignRestrictionsTemporelle(Tab: TMemoryStream);
var Compteur1, Compteur2: Integer;
    Masque: Integer;
    Buffer: Byte;
    Resultat: Byte;
begin
    Tab.Seek(0, 0);
    Masque := 4;
    Resultat := 0;
    Compteur2 := 15;
    for Compteur1 := 1 to 334 do
    begin
        Tab.Read(Buffer, 1);
        if (Buffer = 0) then Resultat := Resultat + Masque;
        Masque := Masque shl 1;
        if Masque = $100 then
        begin
            LoginControl[Compteur2] := Chr(Resultat);
            Resultat := 0;
            Masque := 1;
            Inc(Compteur2);
        end;
    end;
    Tab.Read(Buffer, 1);
    if (Buffer = 0) then LoginControl[15] := Chr(Byte(LoginControl[15]) + 1);
    Tab.Read(Buffer, 1);
    if (Buffer = 0) then LoginControl[15] := Chr(Byte(LoginControl[15]) + 2);
    EcrireLoginControl;
end;

function TNWUtilisateur.CherchePeutChangerPassWord: Boolean;
begin
    Result := (LoginControl[63] = #0);
end;

procedure TNWUtilisateur.AssignPeutChangerPassWord(Ok: Boolean);
begin
    if OK then LoginControl[63] := #0
    else LoginControl[63] := #1;
    EcrireLoginControl;
end;

function TNWUtilisateur.CherchePasswordObligatoire: Boolean;
begin
    Result := (LoginControl[12] <> #0);
end;

function TNWUtilisateur.ChercheTailleMiniPassword: String;
begin
    Result := IntToStr(Byte(LoginControl[12]));
end;

procedure TNWUtilisateur.AssignTailleMiniPassword(Mini: String);
begin
    LoginControl[12] := Chr(StrToInt(Mini));
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheChgtPasswordObligatoire: Boolean;
begin
    Result := (LoginControl[10] <> #0);
end;

function TNWUtilisateur.ChercheNbJoursEntreChgt: String;
begin
    Result := IntToStr(Byte(LoginControl[10]));
end;

procedure TNWUtilisateur.AssignNbJoursEntreChgt(NbJours: String);
begin
    LoginControl[10] := Chr(StrToInt(NbJours));
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheDateExpirationPassword: String;
begin
    FmtStr(Result, '%.2d%.2d%.2d', [Byte(LoginControl[7]), Byte(LoginControl[6]), 1900+(Byte(LoginControl[5]))]);
end;

procedure TNWUtilisateur.AssignDateExpirationPassword(Date: String);
begin
    LoginControl[7] := Chr(StrToInt(Copy(Date, 1, 2)));
    LoginControl[6] := Chr(StrToInt(Copy(Date, 3, 2)));
    LoginControl[5] := Chr(StrToInt(Copy(Date, 5, 4)) - 1900);
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheNbLoginPermis: String;
begin
    Result := IntToStr(Byte(LoginControl[11]));
end;

procedure TNWUtilisateur.AssignNbLoginPermis(NbLoginPermis: String);
begin
    LoginControl[11] := Chr(StrToInt(NbLoginPermis));
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheNbLoginRestant: String;
begin
    Result := IntToStr(Byte(LoginControl[8]));
end;

procedure TNWUtilisateur.AssignNbLoginRestant(NbLoginRestant: String);
begin
    LoginControl[8] := Chr(StrToInt(NbLoginRestant));
    EcrireLoginControl;
end;

function TNWUtilisateur.ChercheDelaiGrace: Boolean;
begin
    Result := (LoginControl[8] <> #$FF) and (LoginControl[11] <> #$FF);
end;

procedure TNWUtilisateur.EnleveDelaiGrace;
begin
    LoginControl[8] := #$FF;
    LoginControl[11] := #$FF;
    EcrireLoginControl;
end;

function TNWUtilisateur.CherchePasswordRequis: Boolean;
begin
    Result := (LoginControl[63] = #2);
end;

procedure TNWUtilisateur.AssignPasswordRequis(Requis: Boolean);
begin
    if Requis then LoginControl[63] := #2
    else LoginControl[63] := #0;
    EcrireLoginControl;
end;

end.
